SystemOrganization addCategory: #'Xpf-Support-DemoData'!
SystemOrganization addCategory: #'Xpf-Support-Morphic'!
SystemOrganization addCategory: #'Xpf-Support-Morphic-Models'!
SystemOrganization addCategory: #'Xpf-Support-Quickstart'!
SystemOrganization addCategory: #'Xpf-Support-Multipoint'!
SystemOrganization addCategory: #'Xpf-Support-Update'!

MenuMorph subclass: #XpfMultiPointMenuMorph
	instanceVariableNames: 'hand'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Multipoint'!

!XpfMultiPointMenuMorph commentStamp: 'mt 12/30/2009 12:31' prior: 0!
I am a hand-aware menu morph.!

!XpfMultiPointMenuMorph class methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:32'!
entitled: aString forHand: aHand

	| instance |
	instance := self entitled: aString.
	instance hand: aHand.
	^ instance! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/6/2010 18:05:41.985'!
add: label target: anObject selector: aSelector enabled: aBoolean icon: aSymbol
	
	self
		add: label
		target: anObject
		selector: aSelector.
	
	self lastItem isEnabled: aBoolean.
	
	Preferences menuWithIcons
		ifTrue: [self lastItem icon: (self iconNamed: aSymbol)]! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:37'!
addInfoText: aString withIcon: anIcon

	self
		add: aString
		target: self
		selector: nil
		enabled: false
		icon: anIcon.! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:32'!
hand

	^ hand ifNil: [hand := ActiveHand]! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:32'!
hand: aHand

	hand := aHand! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:37'!
initialize

	super initialize.
	self initializeHandInfo.! !

!XpfMultiPointMenuMorph methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 14:14'!
initializeHandInfo

	self
		addInfoText: 'User: ', self hand login asString
		withIcon: #xpfUser;
		addInfoText: 'Project: ', self hand project asString
		withIcon: #flagBlueIcon.! !

Slider subclass: #XpfScrollBar
	instanceVariableNames: 'menuButton upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay'
	classVariableNames: 'ArrowImagesCache BoxesImagesCache UpArrow UpArrow8Bit'
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfScrollBar commentStamp: 'mt 8/6/2009 09:12' prior: 0!
This is the original version of ScrollBar without Polymorph extensions.

Inspired by an oiginal design of Hans-Martin Mosner, this XpfScrollBar is intended to exercise the handling of input events in Morphic.  With sufficient flexibility in this area, all particular behavior can be concentrated in this single class with no need to specialize any other morphs to achieve button, slider and menu-button behavior.

Once we have this working, put in logic for horizontal operation as well.

CachedImages was added to reduce the number of forms created and thrown away. This will be helpful for Nebraska and others as well.!

!XpfScrollBar class methodsFor: 'as yet unclassified' stamp: 'dew 3/23/2002 01:30'!
alwaysShowFlatScrollbarForAlternativeLook
	"Set this value to true, if you want to see the flat scrollbar look in flop-out mode as well as inboard.  Otherwise the flop-out scrollbar will be rounded and inboard will be flat."
	^ false! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:22'!
arrowOfDirection: aSymbol size: finalSizeInteger color: aColor 
	"answer a form with an arrow based on the parameters"
	^ ArrowImagesCache at: {aSymbol. finalSizeInteger. aColor}! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'sd 11/8/2003 16:02'!
arrowSamples
	"create a set of arrow with different sizes, colors and directions"
	" 
	XpfScrollBar arrowSamples.  
	"
	| column |
	column := AlignmentMorph newColumn vResizing: #shrinkWrap;
				 hResizing: #shrinkWrap;
				 layoutInset: 1;
				 borderColor: Color black;
				 borderWidth: 0;
				 wrapCentering: #center;
				 cellPositioning: #center;
				 color: Color white;
				 yourself.
	
	self sampleSizes
		do: [:size | 
			| row | 
			row := AlignmentMorph newRow color: Color transparent;
						 vResizing: #shrinkWrap;
						 cellInset: 2 @ 0 yourself.
			
			self sampleColors
				do: [:color | 
					#(#top #right #bottom #left )
						do: [:direction | 
							row addMorphBack: (XpfScrollBar
									arrowOfDirection: direction
									size: size
									color: color) asMorph]].
			
			column addMorphBack: row].
	
	column openInHand! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:22'!
boxOfSize: finalSizeInteger color: aColor 
	"answer a form with an box based on the parameters"
	^ BoxesImagesCache at: {finalSizeInteger. aColor}! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'dgd 3/28/2003 10:18'!
boxSamples
	"create a set of box with different sizes and colors"
	" 
	XpfScrollBar boxSamples.  
	"
	| column |
	column := AlignmentMorph newColumn vResizing: #shrinkWrap;
				 hResizing: #shrinkWrap;
				 layoutInset: 1;
				 borderColor: Color black;
				 borderWidth: 0;
				 wrapCentering: #center;
				 cellPositioning: #center;
				 color: Color white;
				 yourself.
	""
	self sampleSizes
		do: [:size | 
			| row | 
			row := AlignmentMorph newRow color: Color transparent;
						 vResizing: #shrinkWrap;
						 cellInset: 2 @ 0 yourself.
			""
			self sampleColors
				do: [:color | 
					row addMorphBack: (XpfScrollBar boxOfSize: size color: color) asMorph].
			""
			column addMorphBack: row].
	""
	""
	column openInHand! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 20:54'!
changesInPreferences
	"the related preferences changed"
	self initializeImagesCache
	" XpfScrollBar allInstances do: [:each | each removeAllMorphs; initializeSlider] "! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'dgd 3/28/2003 10:13'!
createArrowImagesCache
	"creates the cache to store the arrow forms"
	^ LRUCache
		size: 40
		factory: [:key | ""
			self
				createArrowOfDirection: key first
				size: key second
				color: key third]! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 20:43'!
createArrowOfDirection: aSymbol in: aRectangle 
	"PRIVATE - create an arrow bounded in aRectangle"

	| arrow vertices |
	vertices := Preferences alternativeButtonsInScrollBars 
				ifTrue: [self verticesForComplexArrow: aRectangle]
				ifFalse: [self verticesForSimpleArrow: aRectangle].
	""
	arrow := PolygonMorph 
				vertices: vertices
				color: Color transparent
				borderWidth: 0
				borderColor: Color black.
	""
	arrow bounds: (arrow bounds insetBy: (aRectangle width / 6) rounded).
	""
	Preferences alternativeButtonsInScrollBars 
		ifTrue: [arrow rotationDegrees: 45].
	""
	aSymbol == #right 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 90].
	aSymbol == #bottom 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 180].
	aSymbol == #left 
		ifTrue: [arrow rotationDegrees: arrow rotationDegrees + 270].
	""
	^arrow! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 19:32'!
createArrowOfDirection: aSymbolDirection size: finalSizeInteger color: aColor 
	"PRIVATE - create an arrow with aSymbolDirectionDirection,  
	finalSizeInteger and aColor  
	 
	aSymbolDirectionDirection = #top, #bottom. #left or #right  
	 
	Try with:  
	(XpfScrollBar createArrowOfDirection: #top size: 32 color: Color  
	lightGreen) asMorph openInHand.  
	"
	| resizeFactor outerBox arrow resizedForm |
	resizeFactor := 4.
	outerBox := RectangleMorph new.
	outerBox extent: finalSizeInteger asPoint * resizeFactor;
		 borderWidth: 0;
		 color: aColor.
	""
	arrow := self createArrowOfDirection: aSymbolDirection in: outerBox bounds.
	self updateScrollBarButtonAspect: arrow color: aColor muchDarker.
	outerBox addMorphCentered: arrow.
	""
	resizedForm := outerBox imageForm
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.
	""
	^ (resizedForm replaceColor: aColor withColor: Color transparent)
		trimBordersOfColor: Color transparent! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'dgd 3/28/2003 10:13'!
createBoxImagesCache
	"creates the cache to store the arrow forms"
	^ LRUCache
		size: 20
		factory: [:key | self createBoxOfSize: key first color: key second]! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:29'!
createBoxIn: aRectangle 
	"PRIVATE - create an box bounded in aRectangle"
	| box |
	box := RectangleMorph new.
	box extent: (aRectangle scaleBy: 1 / 2) extent rounded;
		 borderWidth: 0.
	""
	^ box! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 19:32'!
createBoxOfSize: finalSizeInteger color: aColor 
	"PRIVATE - create a box with finalSizeInteger and aColor  
	 
	Try with:  
	(XpfScrollBar createBoxOfSize: 32 color: Color lightGreen) asMorph  
	openInHand.  
	"
	| resizeFactor outerBox innerBox resizedForm |
	resizeFactor := 4.
	outerBox := RectangleMorph new.
	outerBox extent: finalSizeInteger asPoint * resizeFactor;
		 borderWidth: 0;
		 color: aColor.
	""
	innerBox := self createBoxIn: outerBox bounds.
	self updateScrollBarButtonAspect: innerBox color: aColor muchDarker.
	outerBox addMorphCentered: innerBox.
	""
	resizedForm := outerBox imageForm
				magnify: outerBox imageForm boundingBox
				by: 1 / resizeFactor
				smoothing: 4.
	""
	^ (resizedForm replaceColor: aColor withColor: Color transparent)
		trimBordersOfColor: Color transparent! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'dgd 3/27/2003 10:05'!
initialize
	"XpfScrollBar initialize"
	UpArrow := Form
				extent: 6 @ 3
				fromArray: #(805306368 2013265920 4227858432 )
				offset: 0 @ 0.
	""
	self initializeImagesCache! !

!XpfScrollBar class methodsFor: 'class initialization' stamp: 'md 3/23/2006 15:55'!
initializeImagesCache
	"initialize the receiver's ImagesCache. 
	 
	normally this method is not evaluated more than in the class 
	initializazion. "

	" 
	XpfScrollBar initializeImagesCache.
	"

	ArrowImagesCache := self createArrowImagesCache.
	BoxesImagesCache := self createBoxImagesCache! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'dgd 3/28/2003 10:18'!
sampleColors
	"private"
	^ (Color lightCyan wheel: 5)! !

!XpfScrollBar class methodsFor: 'images - samples' stamp: 'dgd 3/28/2003 10:17'!
sampleSizes
	
"private"
	^ #(10 12 14 16 18 32 64 )! !

!XpfScrollBar class methodsFor: 'coloring morphs' stamp: 'dgd 3/28/2003 20:29'!
updateScrollBarButtonAspect: aMorph color: aColor 
	"update aMorph with aColor"
	| fill direction |
	aMorph isNil
		ifTrue: [^ self].
	""
aMorph color: aColor.
	Preferences gradientScrollBars
		ifFalse: [^ self].
	""
	fill := GradientFillStyle ramp: {0.0 -> aColor twiceLighter twiceLighter. 1.0 -> aColor twiceDarker}.
	""
	direction := ((aMorph width min: aMorph height)
				+ ((aMorph width - aMorph height) abs * 0.3)) rounded.
	""
	fill origin: aMorph topLeft + (direction // 8).
	fill direction: direction @ direction.
	fill radial: true.
	""
	aMorph fillStyle: fill! !

!XpfScrollBar class methodsFor: 'coloring morphs' stamp: 'dgd 3/28/2003 20:29'!
updateScrollBarButtonsAspect: aCollection color: aColor 
	"update aCollection of morphs with aColor"
	
	
	aCollection
		do: [:each | self updateScrollBarButtonAspect: each color: aColor]! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:21'!
verticesForComplexArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a complex arrow"
	| vertices aux |
	vertices := OrderedCollection new.
	""
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle topLeft.
	vertices add: aRectangle topRight.
	""
	aux := (aRectangle width / 3) rounded.
	vertices add: aRectangle topRight + (0 @ aux).
	vertices add: aRectangle topLeft + aux.
	vertices add: aRectangle bottomLeft + (aux @ 0).
	""
	^ vertices! !

!XpfScrollBar class methodsFor: 'images' stamp: 'dgd 3/28/2003 10:21'!
verticesForSimpleArrow: aRectangle 
	"PRIVATE - answer a collection of vertices to draw a simple arrow"
	| vertices |
	vertices := OrderedCollection new.
	""
	vertices add: aRectangle bottomLeft.
	vertices add: aRectangle center x @ (aRectangle top + (aRectangle width / 8)).
	vertices add: aRectangle bottomRight.
	""
	^ vertices! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 16:27'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 7/16/2004 19:33'!
buttonExtent
	| size |
	size := Preferences scrollBarsNarrow
				ifTrue: [11]
				ifFalse: [15].
	^ bounds isWide
		ifTrue: [size @ self innerBounds height]
		ifFalse: [self innerBounds width @ size]! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:13'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'di 4/22/2001 18:28'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'di 4/22/2001 18:28'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
downImage
	"answer a form to be used in the down button"
	^ self class
		arrowOfDirection: (bounds isWide
				ifTrue: [#right]
				ifFalse: [#bottom])
		size: (self buttonExtent x min: self buttonExtent y)
		color: self thumbColor! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 2/27/1999 18:22'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r _ self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: self sliderThickness) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: self sliderThickness)])! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dgd 3/26/2003 09:13'!
extent: p 
	p x > p y
		ifTrue: [super
				extent: (p max: 42 @ 8)]
		ifFalse: [super
				extent: (p max: 8 @ 42)].
	! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'jrp 8/3/2005 10:20'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook ifTrue:[
		upButton borderStyle: (BorderStyle complexRaised width: upButton borderWidth).
		downButton borderStyle: (BorderStyle complexRaised width: downButton borderWidth).
	] ifFalse:[
		downButton borderStyle: BorderStyle thinGray.
		upButton borderStyle: BorderStyle thinGray.
	].

! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dew 3/4/2002 01:11'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self roundedScrollbarLook ifTrue:[
		self borderStyle: ((BorderStyle complexFramed width: 2) "baseColor: Color gray")].! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'jrp 8/3/2005 09:55'!
initializeDownButton
	"initialize the receiver's downButton"

	downButton _ RectangleMorph 
				newBounds: (self innerBounds bottomRight - self buttonExtent 
						extent: self buttonExtent)
				color: self thumbColor.
	downButton 
		on: #mouseDown
		send: #scrollDownInit
		to: self.
	downButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateDownButtonImage.
	self roundedScrollbarLook 
		ifTrue: 
			[downButton color: Color veryLightGray.
			downButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [downButton setBorderWidth: 1 borderColor: Color lightGray].
	self addMorph: downButton! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dew 3/4/2002 01:13'!
initializeEmbedded: aBool
	"aBool == true => inboard scrollbar
	aBool == false => flop-out scrollbar"
	self roundedScrollbarLook ifFalse:[^self].
	aBool ifTrue:[
		self borderStyle: (BorderStyle inset width: 2).
		self cornerStyle: #square.
	] ifFalse:[
		self borderStyle: (BorderStyle width: 1 color: Color black).
		self cornerStyle: #rounded.
	].
	self removeAllMorphs.
	self initializeSlider.! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'wiz 12/22/2007 23:01'!
initializeMenuButton
"initialize the receiver's menuButton"
	"Preferences disable: #scrollBarsWithoutMenuButton"
	"Preferences enable: #scrollBarsWithoutMenuButton"
	(Preferences valueOfFlag: #scrollBarsWithoutMenuButton)
		ifTrue: [menuButton := nil .^ self].
	menuButton _ self roundedScrollbarLook
		ifTrue: [RectangleMorph
					newBounds: ((bounds isWide
							ifTrue: [upButton bounds topRight]
							ifFalse: [upButton bounds bottomLeft])
							extent: self buttonExtent)]
		ifFalse: [RectangleMorph
					newBounds: (self innerBounds topLeft extent: self buttonExtent)
					color: self thumbColor].
	menuButton
		on: #mouseEnter
		send: #menuButtonMouseEnter:
		to: self.
	menuButton
		on: #mouseDown
		send: #menuButtonMouseDown:
		to: self.
	menuButton
		on: #mouseLeave
		send: #menuButtonMouseLeave:
		to: self.
	"menuButton 
	addMorphCentered: (RectangleMorph 
	newBounds: (0 @ 0 extent: 4 @ 2) 
	color: Color black)."
	self updateMenuButtonImage.
	self roundedScrollbarLook
		ifTrue: [menuButton color: Color veryLightGray.
			menuButton
				borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [menuButton setBorderWidth: 1 borderColor: Color lightGray].
	self addMorph: menuButton! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:44'!
initializePagingArea
"initialize the receiver's pagingArea"
	pagingArea := RectangleMorph
				newBounds: self totalSliderArea
				color: (Color
						r: 0.6
						g: 0.6
						b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea
		on: #mouseDown
		send: #scrollPageInit:
		to: self.
	pagingArea
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook
		ifTrue: [pagingArea
				color: (Color gray: 0.9)]! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:44'!
initializeSlider
"initialize the receiver's slider"
	self roundedScrollbarLook
		ifTrue: [self initializeUpButton; initializeMenuButton; initializeDownButton; initializePagingArea]
		ifFalse: [self initializeMenuButton; initializeUpButton; initializeDownButton; initializePagingArea].
	super initializeSlider.
	self roundedScrollbarLook
		ifTrue: [slider cornerStyle: #rounded.
			slider
				borderStyle: (BorderStyle complexRaised width: 3).
			sliderShadow cornerStyle: #rounded].
	self sliderColor: self sliderColor! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'jrp 8/3/2005 09:57'!
initializeUpButton
"initialize the receiver's upButton"
	upButton _ self roundedScrollbarLook
		ifTrue: [RectangleMorph
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
		ifFalse: [RectangleMorph
						newBounds: ((menuButton
								ifNil: [self innerBounds topLeft]
								ifNotNil: [bounds isWide
										ifTrue: [menuButton bounds topRight]
										ifFalse: [menuButton bounds bottomLeft]])
								extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	self updateUpButtonImage.
	self roundedScrollbarLook
		ifTrue: [upButton color: Color veryLightGray.
			upButton
				borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton setBorderWidth: 1 borderColor: Color lightGray].
	self addMorph: upButton! !

!XpfScrollBar methodsFor: 'access' stamp: 'dew 2/21/1999 03:08'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval _ d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!XpfScrollBar methodsFor: 'other events' stamp: ''!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event]! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
menuImage
	"answer a form to be used in the menu button"
	^ self class
		boxOfSize: (self buttonExtent x min: self buttonExtent y)
		color: self thumbColor! !

!XpfScrollBar methodsFor: 'other events' stamp: 'sps 3/10/2004 10:14'!
mouseDownInSlider: event
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBars.].
	super mouseDownInSlider: event
! !

!XpfScrollBar methodsFor: 'access' stamp: 'dew 2/15/1999 18:25'!
pagingArea
	^pagingArea! !

!XpfScrollBar methodsFor: 'scroll timing' stamp: 'di 8/17/1998 09:22'!
resetTimer
	timeOfMouseDown _ Time millisecondClockValue.
	timeOfLastScroll _ timeOfMouseDown - 1000 max: 0.
	nextPageDirection _ nil.
	currentScrollDelay _ nil! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 21:26'!
roundedScrollbarLook
	"Rounded look currently only shows up in flop-out mode"
	^false and: [
		self class alwaysShowFlatScrollbarForAlternativeLook not]
! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 14:56'!
scrollBarAction
	^self valueOfProperty: #scrollBarAction! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 14:56'!
scrollBarAction: aSymbol
	self setProperty: #scrollBarAction toValue: aSymbol! !

!XpfScrollBar methodsFor: 'access' stamp: ''!
scrollDelta
	^ scrollDelta! !

!XpfScrollBar methodsFor: 'access' stamp: ''!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta _ d1.
	pageDelta _ d2.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:12'!
scrollDown
	self flag: #obsolete.
	downButton eventHandler: nil.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollDownInit! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'bf 4/14/1999 12:03'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:05'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'RAA 12/29/2000 11:56'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:11'!
scrollUp
	self flag: #obsolete.
	upButton eventHandler: nil.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollUpInit! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'bf 4/14/1999 12:03'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'ar 10/7/2000 15:05'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!XpfScrollBar methodsFor: 'scrolling' stamp: 'RAA 12/29/2000 11:56'!
setNextDirectionFromEvent: event

	nextPageDirection _ bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 16:25'!
sliderColor: aColor 
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor := self thumbColor.
	menuButton
		ifNotNil: [menuButton color: buttonColor].
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor slightlyLighter.
	
	self class updateScrollBarButtonsAspect: {menuButton. upButton. downButton} color: buttonColor.
	
	self updateMenuButtonImage.
	self updateUpButtonImage.
	self updateDownButtonImage.
	
	self roundedScrollbarLook
				ifTrue: [
					self color: Color transparent.
					pagingArea color: aColor muchLighter.
					self borderStyle style == #simple
						ifTrue: [self borderColor: aColor darker darker]
						ifFalse: [self borderStyle baseColor: aColor]]
				ifFalse: [
					pagingArea
						color: (aColor alphaMixed: 0.3 with: Color white).
					self borderWidth: 0]! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 2/21/1999 03:08'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!XpfScrollBar methodsFor: 'access' stamp: 'dew 3/4/2002 01:17'!
sliderShadowColor
	^ self roundedScrollbarLook
		ifTrue: [self sliderColor darker]
		ifFalse: [super sliderShadowColor]
! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'dew 3/4/2002 01:18'!
sliderThickness
	^ self roundedScrollbarLook ifTrue:[15] ifFalse:[super sliderThickness]! !

!XpfScrollBar methodsFor: 'stepping and presenter' stamp: 'ar 10/7/2000 15:02'!
step
	| action |
	action _ self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!XpfScrollBar methodsFor: 'testing' stamp: 'di 4/22/2001 18:30'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!XpfScrollBar methodsFor: 'access' stamp: 'md 2/24/2006 16:26'!
thumbColor
	"Problem: Part of the XpfScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self sliderColor alphaMixed: 0.5 with: (Color gray: 0.95)
! !

!XpfScrollBar methodsFor: 'geometry' stamp: 'hpt 4/3/2003 19:18'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton _ menuButton ifNil: [upButton].
	bounds isWide
		ifTrue: [
			upButton right > upperBoundsButton right
				ifTrue: [upperBoundsButton _ upButton].
			^upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse:[
			upButton bottom > upperBoundsButton bottom
				ifTrue: [upperBoundsButton _ upButton].
			^upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'RAA 7/28/2000 10:12'!
upArrow8Bit

	"convert to 8-bit and convert white to transparent to avoid gratuitous conversion every time we put one in an ImageMorph"

	^UpArrow8Bit ifNil: [
		UpArrow8Bit _ (ColorForm mappingWhiteToTransparentFrom: UpArrow) asFormOfDepth: 8
	]! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
upImage
	"answer a form to be used in the up button"
	^ self class
		arrowOfDirection: (bounds isWide
				ifTrue: [#left]
				ifFalse: [#top])
		size: (self buttonExtent x min: self buttonExtent y)
		color: self thumbColor! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 10:24'!
updateDownButtonImage
	"update the receiver's downButton.  put a new image inside"
	downButton removeAllMorphs.
	downButton
		addMorphCentered: (ImageMorph new image: self downImage)! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'sd 11/8/2003 16:01'!
updateMenuButtonImage
	"update the receiver's menuButton. put a new image inside"
menuButton isNil ifTrue:[^ self].

	menuButton removeAllMorphs.
	menuButton
		addMorphCentered: (ImageMorph new image: self menuImage)! !

!XpfScrollBar methodsFor: 'initialize' stamp: 'dgd 3/28/2003 19:13'!
updateUpButtonImage
"update the receiver's upButton. put a new image inside"
	upButton removeAllMorphs.
	upButton
		addMorphCentered: (ImageMorph new image: self upImage)! !

!XpfScrollBar methodsFor: 'scroll timing' stamp: 'dgd 2/21/2003 23:05'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!XpfScrollBar methodsFor: 'testing' stamp: 'ar 10/7/2000 15:02'!
wantsSteps
	^self scrollBarAction notNil! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/18/2009 13:36'!
databaseRefreshContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKUSURBVDjLhVNdSJNRGH6++enS
Tc3Rl9Y0KzRcoSHShURERRldlLGLMsqrCO2iLuwuL7qKLr0MoQvDHJigJkEbG5mGdzKU1Pnv
N7I2Fgu33Or7W+858YkrpRee8x7ec97n/TtHyGQyCAQCVtJXCS2GYdSQribQ1vhEeon0C0Kg
ublZx18i+P3+43TJI0lSXVlZGWw2GwoKCsCINzY2kEwmEQ6HEYvFPpLtptvtXs9i8Pl872VZ
ZuEyu4mqqplgMJh57O1Ya/e25jByExZaTpSWluJ/4nQ6kdZSTlXRAtvtIkXmTNPT07Db7Rwl
JSVYSS7infwGa8llaJoOTdXhLCwX7Zr97C3PdW9fy2BTFoHD4WB1IhKJIJH3HZPKBA4UOXHh
4GXoGR0GQTd0vk+l0peuPW9aGm7zVolmLSyyKIoUTUMgPoN9uRIk635MRYNY+bYMVVFRXlTB
z0PhBf/Ifd9FloHFzIAdULM4FhMh7jiyMIREfBOte9vwtLEL65+/anNyaFz5qTSdf3Y6P6sE
Xdc5CcO9Qw85UTQaRfJHktvYnTzFqpPzOV/HmEG+6awMzOgmyRahquHtlyF+p0FoTJCz/s8U
GExHk1DRflHjDAxHBpBSNrldURQ0djaMUT/O0DgZuSyySPF4HPQS+QTS6fQfZksuBuQ+5BXl
QFDzceflDWqkJh2tOCydqq/H7Pw8xsYnvILH47lC7P0ul8tWWVkJq9UKQRBw99VtFBcW4+Sx
2q3xmeNcWl2F3z86qWv6I4Gl29vbe4RIOglui8VSzP4CK2dQfo09ksgf0kxoDhpPm/VG/0DO
T1Z7wqOcYLt0d3cXknMVwaCmhjzRHi+l7pjqmq3b8Y1v/xg7ofZBTY6rvbp/t/PfI0AjgZ0q
o+wAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/18/2009 14:04'!
databaseRefreshIcon
	^ Icons
			at: #'databaseRefresh'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self databaseRefreshContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/20/2009 22:14'!
flagBlueContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIxSURBVDjLpdNdSFNhGAdwKSNy
g6ALC8GLoE8so49VRHVRFFQISlJeREXQBxWSSZDUpNrOTDoxSGvhmokV1TazLeekTBda9rVK
mW5lYq6slgutOI7j1vn3vKc4rCAv3MXDgfPy/73Pc3hOEoCkROq/B6v2GdIWHLnhmK1v7ZtZ
3PIuo9DmOr17iaUkLx1Ud6g2jgqo+JCU4x7Bs5AEe4+EhbYYMsv9iEYGcU+/VEZkYNkew7iJ
nHBrgl4YSeYEJJcIGF8qoKw9Bv8g8GkY8IaBthDgqatCsNGAq4czGbBLBhbv5VWT+EiL2Q9c
fg2YA0DDe+AxBeqDQPvX3+/PdwKmfA0+PDDCuGM6A9JkYP5Byyy1SexgQM5dIJvqpJdCb4DW
z8BDKguhhzxDor1Ig+7afBaG8hFnFDiyp1ZFgxa6JbcR2NoEnCLg2ltqfQBwUzcVhJc1+4c8
/Br0urV/A9OKvJyxQ/qmfQ5so/D2ZoB7CVh7gN4fwP1+wEWjGK/XoKt6C9rOrWeATwHUugEn
3RBjrW9oAI4TdJPCno80RlfsZ27d9+Eslxitcdpk4HbxCgboFEB1JvKk3CfhSjdQTXM7+yRo
rCLUZ8PSposvvMZX0bydtf2Vi9JT4avcjIr9GQxYrQBzC2zmVG2nkGIISyncF2mKLiDOKbQ+
it8JCqy9dGCe3EH8/KMu0j9AqePEyoSAwFNTVkKAHG7i1ykrPCbAfmw5A46OBbjw5y9kz8nx
Z78A90vOcDVd+i0AAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/20/2009 22:15'!
flagBlueIcon
	^ Icons
			at: #'flagBlue'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self flagBlueContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/20/2009 22:15'!
noteContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGGSURBVDjLxZO/alRBFMZ/c6Mm
omKhBLv4AIJiYekjCFopKSzyCnkGW99BbMTOQhsrBcFKsLCJhRYBNYYsWXNn5s6Z81nMGu+6
26XwFDOHge/PmfkmSOIk1XHCOvWn0ZdXsulPpAFZQbUgG5BlVDOURLWELEJJXLz3JMwTVOP0
tfsLChIEmC2A4OD5g0UHebLLWQl5bAcBJAcC4i9D6FZRiUtGMMOHb9j0PXhGGtruA3hCnpBH
zly+i5d+CUHNgCFPoDIDjcEJeQ8yNCxxYL/2m+U55Yh7mpFE8NhE7GiRwGsi7bzF8meoA8io
6ZC1jfWm7AnVCPLld1DjPna4y/kbm4Djw1emH56h2oN6VFNzIKOOCI6DFCTKj48cvN6m9jtQ
C64yAjcXrjrnoBu/94VbDymTPSZvHs/A6RgsT0gZqC1M/46AJcJKx7mbW8RPL5m+e8HKpeus
XbmNI1AFDHBkmZHzFpO9p3fkJSNLqEQsfgc6uhCQJRgy7qlF2ypXHynMEfy33/gbubc6XKsT
2+MAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/20/2009 22:15'!
noteIcon
	^ Icons
			at: #'note'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self noteContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/20/2009 22:14'!
pageWhiteTextContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAADoSURBVBgZBcExblNBGAbA2cee
gTRBuIKOgiihSZNTcC5LUHAihNJR0kGKCDcYJY6D3/77MdOinTvzAgCw8ysThIvn/VojIyMj
IyPP+bS1sUQIV2s95pBDDvmbP/mdkft83tpYguZq5Jh/OeaYh+yzy8hTHvNlaxNNczm+la9O
Tlar1UdA/+C2A4trRCnD3jS8BB1obq2Gk6GU6QbQAS4BUaYSQAf4bhhKKTFdAzrAOwAxEUAH
+KEM01SY3gM6wBsEAQB0gJ+maZoC3gI6iPYaAIBJsiRmHU0AALOeFC3aK2cWAACUXe7+AwO0
lc9eTHYTAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/20/2009 22:16'!
pageWhiteTextIcon
	^ Icons
			at: #'pageWhiteText'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self pageWhiteTextContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/15/2009 12:08'!
xpf7LikeFeedback

	^ Icons
		at: #'xpf7LikeFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpf7LikeFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/15/2009 12:07'!
xpf7LikeFeedbackContents

	^ 'R0lGODlhgQAQANUAAAAAAP///+vTLOvRM//qaP/rcv/te//ug//vi//vkf/wlv/xnv/ypf/z
rf/0s+vOSezSSuvTVf/0uv/1w//2zP/41+/OQufBMP/99uvHUOm4M/nWdv/57NyhJ9aXIuuY
Ev///wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAACAALAAA
AACBABAAAAb/QJBwSCwaj8ikcslsOp/QqHRKrVqv2KzWCol4IRDLYCA4As5LdFQNYg/PcKva
vQYgN4F8HlOZUChlRHNKdFKFhVNzdlSIeBQSDg0MCwsKCRMcA4KLb4uKcUJwaKBtnqShnJ1u
opugoqmsqp2oQ3iQkpUJCAcHGBetm7SlworEnIepw8rFy6bEs8u0bhAYkZMKuwbaE7/Axt/N
4Mqtx87h58zB46h0FhzW2AcGBfQKGkau5sz75uvCqvli8fv36h87IxYq4EogrwCBhwY6mNFH
EVw6ZEUwZqyIrh+7ZA8oSIrn8CGBAx4EWeQ4cJxGaG0IrpwZbVg7ChMq4JTwUIGEN5TkyJki
1XJVMmRGk35SWq6cQRAPombIoCHSB6BbsmrdmkQDhw9cw4rlqgHs2LNorZhNy7atlCAAOw=='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:37'!
xpfAccept

	^ Icons
		at: #'xpfAccept'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAcceptContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfAcceptContents

	^ 'R0lGODlhEAAQAMQfAHbDR0twLrPdlpHQaZGYjPn8983muYvSWIPNU3G/RNTtxTZZGn6TbVKC
LJPmV4nkTOz35ajld8LmqV16Rn7VR4DLT4zlUExgPHGLXIvOYKTad4DZSGm4PlJnQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAWE4Cd+Xml6Y0pORMswE6p6mGFIUR41skgbh+ABgag4eL4O
kFisDAwZxwLl6QiGzQHEM3AEqFZmJbNVICxfkjWjgAwUHkECYJmqBQNJYSuf18ECAABafQkJ
D3ZVGhyChoYcHH8+FwcJkJccD2kjHpQPFKAbmh4FMxcNqKhTPSknJiqwsSMhADs='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'topa 4/17/2009 17:32'!
xpfAddIteration

	^ Icons
		at: #'xpfAddIteration'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAddIterationContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'topa 4/17/2009 17:32'!
xpfAddIterationContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0
d2FyZQBBZG9iZSBJbWFnZVJlYWR5ccllPAAAAahJREFUeNqMk79Lw0AUx78X
U/zRioMUUVGci7hUd+Om1LGC2L3+A6VgEXFwEycHuxcEK4LopKCzYIWais6C
WKUKgWpJL5d4lzZNhST64Hgvd+8+933vLsSyLAjbLhaXuRvl45yPRIB/5XvO
0DbJCRhjY1vJZL5SqSSCvMgzTRPOII6CjUIhvZNKHTjfXkYIQa5QWOdh3pmT
ncAwDGLyzYLqZ5Ik2Xndcy6AUggAC1AAvibyPAG0rYAFKBAlUD8FlFIiTjcY
8wfwEkSeN6DZbAGCesDXRZ4fAH+VYLYAuB++sfsBarmA5j8UZO4yOJ46zTbk
7xkOSOPLdB+SAIgrFD3wG+UPFWuLKxP85Dh063cJjgKvEnLlTajag/0ONKYB
up1zCwslF6DrvteovquIKiN2XDNqUJbm4yK+PrlyFWiaJomt/eEw6vU6IpFI
x8fCMTxdPLYaqRBUjsql1r2i1OnBW7XaEwqFMK0o2QEO6fa7C3t43tezRAc+
2SfQ4EcZ1iwvId35mYbm5lZ5EyeZYRz2yPKql6exl6I5+B01+9glZJLGeC9+
BBgAlQAyLU/LNHUAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/24/2009 16:07'!
xpfAddTask

	^ Icons
		at: #'xpfAddTask'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfAddTaskContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 4/24/2009 16:07'!
xpfAddTaskContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAITSURBVDjLpZNNSJRBGMd/s7q5
0ZoWISZSRAgF5VpELFJ0CK9RneokEl1qO3URpFNCXqIO0aFLEF0iiAj6JBB0WYwOoikRJiXU
Yqbsumv7zvu+M/N02BV30YPgc5h5GPh/zMz/USLCVirCFqt+tZGfb8UUFxEJEBMiNkRMgBgf
sT6EGms0YjwINU0Xn6haAmuIHrm0TkEEFFQWQCD3/PJ6B37+N9tFEOeVDxSIOEAhrDGoSAMS
ehtcwRhcMI8pfgLnIxKUdxeA04jTiPPYtucCLixtQGB9wCBOg4QVUDVYI64EYpBgAwdmZals
uUbZwzldIfHAeWUR8289gbMaPTOK8b+DDUAMVheI7W8pKzuNWA/E1byBWg3S4oteibZ0EO86
DzhcMEdx/BkN+3aBlBie1YzMOZY9j6CU489K/tabOxOD9VVMhAuT5D6m2dl9FaUUTkKQEu+/
FZny45w5fYL23R0MT79kbGr0djLV1hyp/u/Gk72E+b/kR+5VwBqxmtdfc3QdSmAjlsTeHqwK
SR7tBri+FmWjUXURdhy/gphmiplX1MUSxFr7WCgsEVVxzh2+AcDNs4842NIJEKvKgSb37j5i
NBJ6BN4XmM1Q+vyUQiFgOpthIpumv+cxQx/6iNU1AGi1mWlMptoG2w80DXR3nqKj9Rgz8+Nk
JtP8+rF8V212nJOptiHgGtAIFIGHYw+y/f8B3ntD1Kp2NbQAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfCancel

	^ Icons
		at: #'xpfCancel'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCancelContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfCancelContents

	^ 'R0lGODlhEAAQAMQfAOt0dP94eOFjY/a0tP/JyfFfX/yVlf6mppNtbf5qanknJ9dVVeZqat5e
XpiMjGo4OIUvL3pGRthWVuhvb1kaGv39/f1lZdg7O/7Y2F8/P+13d4tcXNRTU2dCQv//////
/yH5BAEAAB8ALAAAAAAQABAAAAV/4Cd+Xml6Y0pGTosgEap6G0YQh6FDskhjGg0AMJkwAjxf
BygkGhmCAAXl6QyGnuLFI4g+qNbixLMNdBNfkpXBLncbial6AC17Gvg4eND1BPB3cHJVBguG
hwsSHHo+GRqKHJGRCQo9JI4WBZoFFpUVMw8QCqMQU58qJCclqKytIQA7'
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 19:45'!
xpfCardOcclusionIcon

	^ Icons
		at: #'xpfCardOcclusion'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfCardOcclusionIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 19:44'!
xpfCardOcclusionIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAGBJREFUeNpi/P//PwMlgImBQjDwBrCgCzAyMhIVKMCwY6SN
C+A2fM3AKs7IPYNGYUCs37EFBgM0Mf1fuHAhiEEUhumjfiACXYGhKD4+Hh5tGIEKywuEwoCg
AUM3LwAEGABnkDTmpK46EgAAAABJRU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfClock

	^ Icons
		at: #'xpfClock'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfClockContents

	^ 'R0lGODlhEAAQALMPAOz2/6mjhdrMrMe6kkE4H7OfY7iofJR7PnBgN9Dq/tLT1Ojaw3h/hf7+
/v///////yH5BAEAAA8ALAAAAAAQABAAAAR88MnpqpuYusNPzVLDLeTCNZm4CEM7CMKBSts6
OEhltDl9sBaHorHzPGo3i4IQIBYIlcMi2VgyEgDDs4KYIhqNAAFA1kJxC0ODDGAgEonC9ogQ
GNiJa2DQoxcGAXBwAQIFfQ8NCH8BjFqGMxOJBHJyCF8gRw4Em2eYGh8ZEQA7'
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 5/15/2009 15:08'!
xpfClockEdit

	^ Icons
		at: #'xpfClockEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 5/15/2009 15:07'!
xpfClockEditContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANZSURBVDjLVZN7TFNnGIdPTMwS
Y/aHyTJjYkJmIjNT/zCLMS4uoomKRhMTTcjwMoJCWDTGeUFAtmIkoKIoA4QqoJRLrKyzLQ63
qS2ltDtcpOXYQi1SbMFSodALp1fbn+9pgGwneU6+vN/7e75LzmEAMHNPmSWEiDASPcRnQv2/
UO3L+XmWSF6oM7MyZilxfa43fTwyrYK394iLVezXnn8eURPuedT/Kg5qfAM50wHzZTf1s8Tq
hMDVyhR42aMT4cmnmNJnzPZJt/pLtdOo7HWhzuBMIIxvaUZhkG7iPVwR7zec+0C5fmIp43jA
FPqMl92TXRmzuqat0Qq9HY+M79GiGUO1zISKxyY8eDGKloFx1HeqMKTYHQs4Hn+cfLLOQtlk
5m0ts21YvMzSfX8jf101ilbWDpnKhhGHF9NeP6a8c7DYvZD8PYL6LhseyctgbNkSMos/f0XZ
5MRFnK9T3sj9nYNYa4OUVhOeGY8HbyacCNJYwB8H/lA2Y7g5DVZ5MQx1u2Cs+uZYQpBe26++
0MahpsMCM63MR+Pw8zyq6hvgIpEvFIL6WQmcL3PhGWwn2wRmB9ugL9szmRAcuq1xn215hWvN
RrgCEcyEYgjTRJ6oCE0yOe7dyYDbJELYoYBTfQMBToaPY1pwDVnBhOBASYc76z4LUcMA7P4I
SWJweHy4WnYT1eXZmHldiFhAi8DbU3D3nMaQJBOsODPeU3FwbUKw55c2dVq5CkWSfnRaPXhP
h3b4Iuj8pxozXB5iQT34keMI2tPhM+eDq9mH7CuVfYnvQHilXHgo2it6gjP3dCiVWjBFF2Yd
lMPZmzsfPobgux/gfV0Ac1Uqhe9CyCwKvjtd/S1h2lWoxNlaDWrqxDD/dZG2rUHQlomQ/Sg8
tJOhqt1I+7UJQq+QWRQIbD5Zlp1TKuGzfr4I05/5MHbcxjh7GLwtHW7DJQz8tg8/lUhwovgh
L/Qu/gsLA51Ol8JxHKTXdgK+MQyLD+Fl/ip016RCKdqOjLxydGm74906XZx6v/+foL29/QvC
b7VacTVrA8L6SoTZO2CLU9CcmRTf/2NO3/q0ApFCqfRZLBZQb5RYsyhobGxcTgwT4cPbVoRK
jn8dfVGaGn1+c0enMnfDVwur0XwS4SEmiJVC7RNi1+PWy99nOwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mig 4/15/2009 19:01'!
xpfClockPlay

	^ Icons
		at: #'xpfClockPlay'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockPlayContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mig 4/15/2009 19:00'!
xpfClockPlayContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAANBSURBVDjLXZNrSFNhGMcPQQQRfYv60meJ
oiCtROuDZRcEA6MP3ckwS0tlZVlptnXRqavMaqZ5Ka1Jq1bOmWiXs466mqZzLs0103CmLp27HOdl
af+es2xFL/xe/jzv8/+/vA/nMACYsWpmDiEmjEQTMU+o/wvVFs+e64mAP3XGoWLmEtljzXv7vSMs
XM37bHp1ZEPyK6+WsM+ifa+O4tyGuJHxzjQ79euJpb4AWwWT6tLv/zY1VI3hd9GOD8oQXtowglvN
NhS3DfoQ9DWuB23K1R6nSeLh205+J18LMZex3mPOu41p9qH6aIfuQciPvHd9eGQcgIL7CrmqA3mP
O3DvdQ8Uhn6UvGXxSb11Ztz6eHro+TIzeQOYLwXMhq7C+ebGopWebLYHFfo+qNhedFtdGHHxGHaN
wdznQnldN0rqe/GoUgajIniys3BhK3kDfINILq7KSXlqQmFDL5R0m7BGnU58/jaICdIC/E/gjqYb
cq0F6UoO8aW6K74ZCNveghbtqScm3Kkxo5Nu9vz4Cd7jwe2SUtgoyD05iae1b8B9diJT2Q6hV/D4
A3bmcnaRohVZD42wjXsxOjmDKTo4K5bggaoSKRckqNPpwQ5acEKuh9ArePwB2zNr7LFFeohLDejj
vRQyA6vTjcuyqz4zZ2hHWtMJiOpjkfDmEGLL1BA8/oBt6U+0u66zkJS34K3FiQF6tNXtxQttI3rs
LgxNAymNiSjvzsfVVgkSa2MQmXWrxR8Qduq+OEL8HEl3dZAqzRimgY16AfcMQdpBASfZeJSY81BM
SBpTEK3cjUj55rW+gNAEeRDRseV8FUQFHLKUXTD0OsDTPHiPF0bShyujkd8hwyXDaeR9lCK57hjC
czb8/dbXHpYdiZOWe8LPPMMB2UuIbnJIvtEA0fV6HM9lsU+xG7ntGTjXlIgc40UkaGKwXrxmwh+g
0+nCTCYTXrPcdOixIqw5rsC6JJUPQe+4G4Ws1guQGtIRrz6EkPQgb+Dplb+foNFoFhG8xWKBuqrK
vmpPmmTFrlQtYZ9FG3Fj84Sk6QyOVh5EcGogDmTv2eEfYllZ2QKii5gilv//KwtslIaORuRuQvC5
QEjzM4apb4lQ/wXCx9fe4QKeWQAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mig 4/15/2009 19:02'!
xpfClockStop

	^ Icons
		at: #'xpfClockStop'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfClockStopContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mig 4/15/2009 19:00'!
xpfClockStopContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMsSURBVDjLXZNrSBRhFIaHIIIyu1q/+hdY
JBVhJUmE0EWiC0U/ukM/KroRllGR1S4UWVnZTdJMS2ujrbZSK7ruNK5rm+m6bV7WNbfc1F3d2d3Z
cUxH7e18k1k08AyHb87zHuYwwwHgOp9yQwgd4SA+EMPY+b/Q2cSB5zYi9s85FzJxQ4kznRUbvqsB
M6SKjX5b0XJL6muVJ8QB+PdFq4SIfUegqzZNpH4bMUkL8N/ljki2TS09vqfoKN8S+micJ6dbArhS
4ceN6jYNVp8XmlBtnKWEnXpFrt7fTl4lMZTz3uSORhxpoq90S8h6e17vpfJm3HO0wiB8RZapBpfu
1+DmmyYY7N+R986MuqIl/V3e+32+x1Nd5MZyX7K5+fU5w11ludOVM+Ym3LU1w2T2oNErISDJ6JA6
4WqWUPiyEXmlHtx7kgGHIaG7Nie6itxYbRGpN4rPHnzoRI7FAyNNY1cwHEZDSxt+UM2QfwLXShqR
xbtxzChgZ771pLYDdtuQXckfeODEtecu1NJkpfcnZEXB1bx8+Cko0t2Nhy/eQmgI45TxE1gvcwYD
1mQKYoqhCqfvOODvUhHs7kcPPTis0+O26QkOHtfjpdUGZ1jFviwbWC9zBgNWnHoubsu1QZdvR7Os
Ukg/vOEITmSc02TB/gkdvcDHgIo9meVgvcwZDEg+9oBfe8EMfWEl3rnDaKWX9kZUPOPL0CRK8PUB
HgV49DmEfdnvwXqZMxiQdOCWbqnuMfZetyLd6EIHLSyoApF+guoQBUjr1kOeMAFSTAyCRGD8eLSN
G+fRAhL3ZMUTNYuPFiMlW8BpYz3snhBk2oesqHBQzURl9Wp0rlwJadkyhJKT8XXs2L/f+pytGdt3
pBcqCw89wuaMV0i5LCD1ogUpF0qxO9OsTWSiOHMm2uPi0J6UhLrRo/8GWK3WJKfTiTdmoS9xVy5m
7zZg7l6TBqu9NE1ctAhtU6agZfJktCYmoio6+rdcUlISQ8hutxtFxcXijPVp+ri1R3hCHIBvGDMG
vgULNNGbkIBv8fEoi4r6HVBQUBBF1BM9xLT/f2WGc9SoOjaxYuRITbQQ/IgRwV81l9Ohf930iQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 11/25/2009 10:32'!
xpfDeleteContents
	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJdSURBVDjLpZP7S1NhGMf9W7Yf
ogSJboSEUVCY8zJ31trcps6zTI9bLGJpjp1hmkGNxVz4Q6ildtXKXzJNbJRaRmrXoeWx8tJO
TWptnrNryre5YCYuI3rh+8vL+/m8PA/PkwIg5X+y5mJWrxfOUBXm91QZM6UluUmthntHqplx
Uml2lciF6wrmdHriI0Wx3xw2hAediLwZRWRkCPzdDswaSvGqkGCfq8VEUsEyPF1O8Qu3O7A0
9RbRvjuIttsRbT6HHzebsDjcB4/JgFFlNv9MnkmsEszodIIY7Oaut2OJcSF68Qx8dgv8tmqE
L1gQaaARtp5A+N4NzB0lMXxon/uxbI8gIYjB9HytGYuusfiPIQcN71kjgnW6VeFOkgh3XcHL
vAwMSDPohOADdYQJdF1FtLMZPmslvhZJk2ahkgRvq4HHUoWHRDqTEDDl2mDkfheiDgt8pw34
0/EocuClCuFvboQzb0cwIZgki4KhzlaE6w0InipbVzBfqoK/qRH94i0rgokSFeO11iBkp8Ed
V8cfJo0yD75aE2ZNRvSJ0lZKcBXLaUYmQrCzDT6tDN5SyRqYlWeDLZAg0H4JQ+Jt6M3atNLE
10VSwQsN4Z6r0CBwqzXesHmV+BeoyAUri8EyMfi2FowXS5dhd7doo2DVII0V5BAjigP89GEV
Atda8b2ehodU4rNaAW+dGfzlFkyo89GTlcrHYCLpKD+V7yeeHNzLjkp24Uu1Ed6G8/F8qjqG
Rzlbl2H2dzjpMg1KdwsHxOlmJ7GTeZC/nesXbeZ6c9OYnuxUc3fmBuFft/Ff8xMd0s65SXIb
/gAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 11/25/2009 10:32'!
xpfDeleteIcon
	^ Icons
			at: #'xpfDelete'
			ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeleteContents readStream) ].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:41'!
xpfDeveloperIsOffline

	^ Icons
		at: #'xpfDeveloperIsOffline'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeveloperIsOfflineContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:41'!
xpfDeveloperIsOfflineContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAQAAAC1+jfqAAAACXBIWXMAAAsTAAALEwEAmpwY
AAADG2lDQ1BQaG90b3Nob3AgSUNDIHByb2ZpbGUAAHjaY2BgnuDo4uTKJMDAUFBUUuQe5BgZ
ERmlwH6egY2BmYGBgYGBITG5uMAxIMCHgYGBIS8/L5UBFTAyMHy7xsDIwMDAcFnX0cXJlYE0
wJpcUFTCwMBwgIGBwSgltTiZgYHhCwMDQ3p5SUEJAwNjDAMDg0hSdkEJAwNjAQMDg0h2SJAz
AwNjCwMDE09JakUJAwMDg3N+QWVRZnpGiYKhpaWlgmNKflKqQnBlcUlqbrGCZ15yflFBflFi
SWoKAwMD1A4GBgYGXpf8EgX3xMw8BUNTVQYqg4jIKAUICxE+CDEESC4tKoMHJQODAIMWgx9D
JcMqhgeM0oxRjPMYnzIZMjUwXWLWYG5kvstiwzKPlZk1m/UqmxPbJnYV9pkcAhydnKyczVzM
XG3c3NwTeaR4lvIa8x7iC+Z7xl8tICSwWtBN8JFQo7Ci8GGRdFFe0a1iceKc4lslUiSFJY9K
VUjrSj+RmSMbKicod1a+R8FHkVfxgtIU5SgVJZXXqlvVGtX9NGQ13mru05qonapjrSuk+0rv
iP58gxrDKCNLY0nj3yb3TA+brTDvt6iwTLTysbawUbUVsWOx+2r/3OG24wWnY857Xba6rndb
6b7UY5HnQq8F3gt9Fvsu81vlvz5ga+DeoGPB50NuhT4L+xLBFCkYpRRtHOMWGxWXF9+SMDtx
c9LZ5OepTGly6TYZUZlVWbOy9+Tcy2PKVy/wKSwuml18uORtmUS5S0Vh5byqs9V/a/Xq4usn
NRxr/N1s0JLeOq/teodgp3dXe/fhXoY++/66Cfsm/p/sOKV16onpvDOCZ86a9WiO1tySefsW
cC0MW7R48celDssmLH+40nhV6+qba3XXNa2/udFgU8fmB1uttk3d/mGn765Vezj2pu87fkD9
YOeh10f8jm4+Ln6i9uST095ntpyTPd9+4dOluMunrlpcW3ZD9Gbrra930u/evO/z4MAj08er
nyo+m/lC8GXXa+Y3dW9/vi/98OlTwed3X/O+vfuR//PD7+I/3/5V/f8PAC4MHYugPAkxAAAA
IGNIUk0AAHolAACAgwAA+f8AAIDpAAB1MAAA6mAAADqYAAAXb5JfxUYAAAF2SURBVHjabNG/
S9RxGAfw133O89ILi6OrE/qBmwhGgoI0JRFYgRBEEV0QDQ0F0eJiEf0XbbYUtBVEDSEFQeBS
kbZIUBBmGibpdXee3X0/Df5q6P1sr2d4w/OkovVMl+oX/vRWCqupWmVtNvP43N11T0VMdSbj
O4Z3atcq7bc57618yY+UPpKKpnOrr/YO7BM1RA1kZUx4u9TVU1oILN/JDRQ1BW065HVoWjJs
T/77fQLli3mJIIWGhqhVsOC4uSFaqBZyVgVpaxJRU1pZzUHVLC3UfvzcX/BZ2mstEstOKiv6
JtQJhIcfZDU9MqhfnxPuqTnkuV2TBNpuz8+80S2LtLRETp8JU/XiVQJnGu3n3y1O2o0myHvp
QaPnys1PG4divH/+ab3Y7YhoxhOx3Ht29AWIG3Pr9PDa5TgSh+LhmElGj216avMXDH49eiCx
ouzZYrWwqWFrrzbb5YZTOoVf27pVEY1d6qiERJKpXr+2rf9U/D9/BwA9Z5PtuXkkmQAAAABJ
RU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:42'!
xpfDeveloperIsOnline

	^ Icons
		at: #'xpfDeveloperIsOnline'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDeveloperIsOnlineContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:43'!
xpfDeveloperIsOnlineContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAACXBIWXMAAAsTAAALEwEAmpwY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'
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'topa 4/23/2009 15:51'!
xpfDone

	^ Icons
		at: #'xpfDone'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfDoneContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'topa 4/23/2009 15:51'!
xpfDoneContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAGrSURBVDjLvZPZLkNhFIV75zjvYm7VGFNC
qoZUJ+roKUUpjRuqp61Wq0NKDMelGGqOxBSUIBKXWtWGZxAvobr8lWjChRgSF//dv9be+9trCwAI
/vIE/26gXmviW5bqnb8yUK028qZjPfoPWEj4Ku5HBspgAz941IXZeze8N1bottSo8BTZviVWrEh5
46EO03EXpuJOdG63otJbjBKHkEp/Ml6yNYYzpuezWL4s5VMtT8acCMQcb5XL3eJE8VgBlR7BeMGW
9Z4yT9y1CeyucuhdTGDxfftaBO7G4L+zg91UocxVmCiy51NpiP3n2treUPujL8xhOjYOzZYsQWAN
yRYlU4Y9Br6oHd5bDh0bCpSOixJiWx71YY09J5pM/WEbzFcDmHvwwBu2wnikg+lEj4mwBe5bC5h1
OUqcwpdC60dxegRmR06TyjCF9G9z+qM2uCJmuMJmaNZaUrCSIi6X+jJIBBYtW5Cge7cd7sgoHDfD
aAvKQGAlRZYc6ltJlMxX03UzlaRlBdQrzSCwksLRbOpHUSb7pcsnxCCwngvM2Rm/ugUCi84fycr4
l2t8Bb6iqTxSCgNIAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfEdit

	^ Icons
		at: #'xpfEdit'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfEditContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfEditContents

	^ 'R0lGODlhEAAQAMQAAGB3lYivyMDf/XiZt+Ts9ajT/Mbh/UlVa/P2+bLY/FRlfu3x9ZzN++Xy
/rTR4ENLXN7v/tTk8Jm/1enx96jL3uDo7ykxQz5FVb2JAP+8Bv/RV6HQ/FSr9qfR+jhllf//
/yH5BAAAAAAALAAAAAAQABAAAAWV4CeOZClGjkNJUhAMsOdJohMRUz4RvNdxntrEQCQKGj6g
QkRBFAXHpAex/EicBijy54FQRddslAspfD8BhBZDLpgPovQRo8l0C50NAf4ZLBp0GRhleXoP
In4RdYN4GxsMFYd9CwkKlgoAAwybFReICAkJeAUDAKYAC54fABEIOzwEFbILDhaImJcHBw8P
FxcWVSbCIiEAOw=='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/14/2009 14:26'!
xpfFeedback

	^ Icons
		at: #'xpfFeedback'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfFeedbackContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/14/2009 14:25'!
xpfFeedbackContents

	^ 'R0lGODlhEAAQAMQAAP/99v/qaOvOSem4M+zSSv/ypf/ug//1w//2zP/xnv/te//zrf/0uv/4
1/nWdufBMP/vkevTVf/rcv/0s//wlv/57OvRM//vi+/OQtaXIuuYEuvTLNyhJ+vHUP//////
/yH5BAEAAB8ALAAAAAAQABAAAAV+4CeOZEl6aKqWHhG9BIFZ1uaNnqN6QHMgCNsn50EwJotC
IkGBHCoWlO6YZEIuBgPggSIAkEoKVkE+cD2YClhsUEjelAEK06hC2pKAXsFBCRBJbHl6AQYZ
N2gIBw2KDHoUDIc4ApQdHQNIGpInOwMVGjcmLAOgoiYepaYsoR8hADs='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 16:22'!
xpfGridHoverIcon

	^ Icons
		at: #'xpfGridHover'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfGridHoverIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 16:22'!
xpfGridHoverIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAFBJREFUeNpi/P//PwMlgImBQsACY3R1dZHklLKyMkYUA6CA
EYn9nwCfOl6gXhggOZNYPuEwKC8vh3M6OzsZhmAYQJ1NfhgMjXTAOOC5ESDAAEdmGMAIlkPJ
AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 15:58'!
xpfGridIcon

	^ Icons
		at: #'xpfGrid'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfGridIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 15:57'!
xpfGridIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAADpJREFUeNpi/P//PwMlgImBQsACYzAyMpLkFKDLGVEMQBaE
GYiPTzUvUGwAIywWRsNgNAwG1AUAAQYAtb05E6xvSrgAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/30/2009 11:19'!
xpfHammerScrewdriverContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAq5JREFUeNp0k11Ik1EYx5+zsZaNSWxt0boQLYRgCtrVzESQ
IJAhFUKiEDSYu/DCjF7EuhBRECH6oiChLipBu1lS2YWLpKYLClorSppRG5q6cM5tuW/f/g9M
k1oHfjt7d57/b+fjPaK5uZm2N1mWubODLAiDlY2NjSBYAql0Ok25XG6rXmkwGKxFRUX1CJrA
l0wmwwWfwBK+myoqKo6Ul5cfi0Qi+9bX15WQrKAuuyUIBAL1brf7NvAuLy9PJxIJUqvVXBCF
ILCwsKBvb28/a7VaT2q12v1+v1+g5hv+IA0ZKVFocjqd3v7+/lafz1ccCoWmISIeTKVSWZBJ
JpNGs9lcazKZDpWWlu6ZnJycz2azfkAKCB7DOtTW1jbicDhasSSJB4LBIK2trVE0Gv0BcZBn
BjmVlJRY4vG4kcf4WbG5lrm5uSGbzTbS0dHRajQaJd6oxcVFWl1djSkUCiM/8wZiWapYLMZU
Qk7/tLKyMglLel9VVSUd1Wo11dXV0sTExHuLxXKZTwey7qmpqYBer7frdLoGKtSwTmlUkl66
NRqfz2YL8fO24UqWhMNhOX/cBduJu0S/5MFB2alSzd8U4vCsEOQA+dbAEvQHC4XPAO9wTY2M
itxKU1ME4fHPQpz3QnDrj6RguwQ+1NXV8fQSx4n6nhK9jdvtMsJP3gkheSC48h8Jb9JsY2Mj
h5Pg3Gl8PCIacEKS6OyUEX42I0T3cwgeYuzUtvBV8LWlpYXDaXCdfzQDhLl4YAySdE+PjLDL
JcRFFozkwzdA0I5p5i/Qg7+nxtftPiT3IMn19ckIvxol6t0U/Ozq6uIwX7FxYAC7wS6gBjuB
FugvEF27AwmfzjDRm2G+TEDn8Xhq0WO/qBfsAPyGspR3SwU0oHiG6OMBor3fXS7la6KxF0Qz
vwUYAHOGWZhFPrMZAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/30/2009 11:20'!
xpfHammerScrewdriverIcon

	^ Icons
		at: #'xpfHammerScrewdriver'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfHammerScrewdriverContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:39'!
xpfHistory

	^ Icons
		at: #'xpfHistory'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfHistoryContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'SR 4/14/2009 11:38'!
xpfHistoryContents

	^ 'R0lGODlhDAANAMIEAAAAgICA/4+w1LTR4P///////////////yH5BAEKAAQALAAAAAAMAA0A
AAMhSLq8AaExQIMVeKgXpffcR1DQlW2QqKKdR1oBJmhEuH4JADs='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/28/2009 12:20'!
xpfLogin

	^ Icons
		at: #'xpfLogin'
		ifAbsentPut: [Form fromBinaryStream:
			(Base64MimeConverter mimeDecodeToBytes: self xpfLoginContents readStream)]! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/28/2009 12:29'!
xpfLoginContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAEuSURBVDjLpZM9SgRBFIRr/EHX
wGVFAxUPYmTgMTyEoblX2NwjGG9i5B0EMTIQFWTBaHTeqyqDHmdX0FlhHzSvO6n+qvp1ZRvL
1AqWrLX5w93VuSXBJkhCKovMrpOJk4vr6lcBidg7PgVMWIYkWATEbv9wc/03AZkwiY/3J7i9
3STcEmxu7yOz6ReQCDFhFTExIRJWgox+gcwot2UUAmY5kzADzkBEL0Er0PUZReUGIhcRNAU5
muI/E1JiZzjF4cEbHp+HyIx+C2otdPgqfTodoP5c/w9BgNn8sPD6sgFzFVu76ieIaGYhMtrw
WiGVPRkLCLJkYJX0vyms8rQLMigWBqMj2IKZsFSWCbGM83xVtjGZTFzXNeL2spv3+fmf/QnC
Ju5HZwCA8XhcVct+5y9H3H2zjxE/HwAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/28/2009 12:20'!
xpfLogout

	^ Icons
		at: #'xpfLogout'
		ifAbsentPut: [Form fromBinaryStream:
			(Base64MimeConverter mimeDecodeToBytes: self xpfLogoutContents readStream)]! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/28/2009 12:18'!
xpfLogoutContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJHSURBVDjLlZPNi81hFMc/z713
7p1mTCFvNZfGSzLIWNjZKRvFRoqNhRCSYm8xS3+AxRRZ2JAFJWJHSQqTQkbEzYwIM+6Yid/z
nJfH4prLXShOnb6r8/nWOd8Tcs78bz0/f+KMu50y05nK/wy+uHDylbutqS5extvGcxaWqtoG
DA8PZ3dnrs2srQc2Zko41UXLmLdyDW5OfvsUkUgbYGbU63UAQggdmvMzFmzZCgTi7CQmkZwd
EaX0JwDgTnGbTCaE0G4zw80omhPI92lcEtkNkdgJCCHwJX7mZvNaB0A14SaYJlwTrpHsTkoF
lV1nt2c3x5YYo1/vM9A/gKpxdfwyu/v3teCayKq4JEwT5EB2R6WgYmrs2bYbcUNNUVfEhIfF
Yy69uci+1fuRX84mkawFSxd/4nVWUopUVIykwlQxRTJBTIDA4Pp1jBZPuNW4wUAPmCqWIn29
X1k4f5Ku8g9mpKCkakRLVEs1auVuauVuyqHMo8ejNCe+sWPVTkQKXCMmkeZUmUZjETF1tc6o
oly+fgUVw9So1/tRN6YnZji46QghBFKKuAouERNhMlbAHZFE6e7pB+He8MMw+GGI4xtOMf1+
lsl3TQ4NHf19BSlaO1DB9BfMHdX0O0iqSgiBbJkjm491hClJbA1LxCURgpPzXwAHhg63necA
Ii3XngXLcRU0fof8ETMljIyM5LGxMcbHxzvy/6fuXdWgt6+PWncv1e4euqo1ZmabvHs5+jn8
yzufO7hiiZmuNpNBM13rbvVSpbrXJE7/BMkHtU9jFIC/AAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/28/2009 12:31'!
xpfMedal

	^ Icons
		at: #'xpfMedal'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfMedalContents readStream)]! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 5/12/2009 18:45'!
xpfMedalContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAIHSURBVDjLfZKxa5NBGMZ/35dE
amtFMkgGpaAVQcTRLp1LoYubi6MOgqiTZOrQxYKjOIh/gIuim5YqdChKl4KbQ0XESoPYaGq+
fHff3fu+DklM2lRfeLg7uOd3z929iZnRL7l9y7hwkbi6isWIiaAhoL2xMj+PvVlj4u1K0veU
Gaphkw0ZNcbuOkasCMOWA4AQsRhR79EYu6AY/87LhwDSfYAiYN7D1BTiPeo94j3iHMn0NNrJ
saL4T4IiLNH+sFhZ2KFy9Qcc8aga0knR3S/oWrO751+A8p332+bSNmfuHmP8PEZKqjlJaKF7
HynGHrZ1wW0Pe5L+L8R3p2YwXjL9qGal42hsQvyNSYaJgyQBCbQ36w0puFK7Zhv73sAk1Dl9
r2blE1j8BZJj4nrKUP8d04yxczdrYY/6yBU0FrOliUtY3MPU9eR7cph20PCTdPwkIWN25BdU
pWppGdMc1PfkBhIH0gYLxILqKEAULIIWg+j902WQCPPE4pA+0ChNCy3MwoHobgBBkaJDyGmO
AoJbl90NkqS0P770Rguk6VHyna90WqyPAMSx3N6831C3C6UxzCImvSQoSXmS6BI+PX/VyDOW
R/oAYOdxckMCS5OXr9cq1bOQGBYzpGiRfdti6+nrRp6xOPfMnhwKAPj8IJkpWtSjY1Yi1eDB
dWi6jHURludedBuoX38Av56vLTwJJBoAAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 15:58'!
xpfMoveCardIcon

	^ Icons
		at: #'xpfMoveCard'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfMoveCardIconContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 12/1/2009 15:59'!
xpfMoveCardIconContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAAGXRFWHRTb2Z0d2FyZQBBZG9i
ZSBJbWFnZVJlYWR5ccllPAAAAGJJREFUeNpi/P//PwMlgImBQkCxASy4JBgZGfH6Deh1RrwG
gBV9zcBuOPeMQRQGjOjRCPI7yH/EhgGKATDNZHkBWTOy7YRcgtMLxLqIiRLNKC4gx/8oLsDm
f7Kike4JCSDAACwsQxE2VhXfAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 5/6/2009 16:09'!
xpfOpenStories

	^ Icons
		at: #'xpfOpenStories'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfOpenStoriesContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 5/6/2009 16:09'!
xpfOpenStoriesContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAAK8AAABkCAYAAADwvWACAAAACXBIWXMAAA7EAAAOxAGVKw4b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'! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/26/2009 18:10'!
xpfPassword

	^ Icons
		at: #'xpfPassword'
		ifAbsentPut: [Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfPasswordContents readStream)].! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'cs 5/26/2009 18:11'!
xpfPasswordContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAH2SURBVDjLjZNLTxNRGIaJv6ZN
WeBwkZFLQtGAC4l/wKULV+7YILeSYukEUhJoSASVuCI0hpAYDSUQCJBSoAaC0wbBUi4aWphp
O52Zlpa+nnOqCAptJ3k3M3me73LOlAAoyZfDqQdOEvyO89/vRcGZ5HeWmySFYdWHVOQN0vE5
8jrLJMFJ82hewVU4+bMfqdPxP9VBn+A4D88wP59PwFqmsH7UgeTJEMlsTuIyI5uRsDfCMcmt
AtoyhVmOu5kkHZuFsiNA3XuEi+QCdhxluL0D/SvpoO+vhIksiItNiPqqyXgfIL403gjfoTsI
L70gQBdim3VQvz2FFnwOxf8E8kYF0rIVYqcRM70Vgf/Pe/ohwsutOJdcpBpP4Mek+jPEfbWQ
VzkG+7tNcNsqt68tkcLZTIzM6YZ21IbolgHq9j1o+z04nKhHRnlH2p6A32LCvFD55fIYr960
VHgSSqCFVDJBEeugh+zw2jnpc0/5rthuRMBaioWBqrVrFylXOUpankIi0AjJY0DC3wD9oA9r
Anc2bat+n++2UkH8XHaTZfGQlg3QdlsIbIVX4KSPAv+60L+SO/PECmJiI1lYM9SQBR7b3ein
fn6kEMwEIZd5Q48sQQt1Qv/xFqt2Tp5x3B8sBmYC71h926az6njdUR6hMy8O17wqFqb5Bd2o
/0SFzIZrAAAAAElFTkSuQmCC'! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'topa 4/23/2009 16:01'!
xpfPencil

	^ Icons
		at: #'xpfPencil'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfPencilContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'topa 4/23/2009 16:21'!
xpfPencilContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0RVh0
U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAFUSURBVDjLrZM/SAJxGIZdWwuDlnCplkAE
m1zkaIiGFFpyMIwGK5KGoK2lphDKkMDg3LLUSIJsSKhIi+684CokOtTiMizCGuzEU5K3vOEgKvtB
De/2Pc8H3x8NAM1fQlx4H9M3pcOWp6TXWmM8A7j0629v1nraiAVC0IrrwATKIgs5xyG5QiE+Z4iQ
doeU2oAsnqCSO1NSTu+D9VhqRLD8nIB8F0Q2MgmJDyipCzjvYJkIfpN2UBLG8MpP4dxvQ3ZzGuyy
BQ2H+AnOOCBd9aL6soh81A5hyYSGWyCFvxUcerqI4S+CvYVOFPMHxLAq8I3qdHVY5LbBhJzEsCrw
utpRFBlUHy6wO2tEYtWAzLELPN2P03kjfj3luqDycV2F8AgefWbEnVqEHa2IznSD6BdsVDNStB0l
fh0FPoQjdx8RrAqGzC0YprSgxzsUMOY2bf37N/6Ud1Vc9yYcH50CAAAAAElFTkSuQmCC'
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:23'!
xpfScreenDisconnect

	^ Icons
		at: #'xpfScreenDisconnect'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenDisconnectContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:21'!
xpfScreenDisconnectContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAMySURBVHjaYvz//z8DPrD6+EeW
X3//SP369Vf6+48/ot9+/lID4rav33/t/fztpz9AALHg07zi6AdOoMa9f/7+tvz1+y/D379/
GFgYfjOI8zEzPPrxx+Pdp+8bAQIIrwHff/7KZWP+b8nPxcTw8/c/hp+/GIFiTAwfv/5k4GBl
ZHj74ZMzQAAx4vLC7J3P2b7+/PNRUoCV4/vPnwxvPv0AGcjw9ccfBl5OZoYbD94yPHz8vhQg
gJhw2Z7qLvnr07fvfQ9efQJq+sXADnTrhy8/GT5+/sbw5dt3hndvvjD8+vj1FkAAYXhh0cG3
cn/vbar7/fs3c11aWmLahBPfP33/Uy0hyMbBy8HE8PzNDwZmJnaGLx+BBnz+9hoggOBeWHbk
HScwoJb9/vjEU5bjJTsrKyvDhQsXFhQXFye6lm+z+fP95y4ZMV5Obh5WYHj8Zrh87B7Dj8/f
5AECCGwA0FYWoI3X2FkZVRn+/2V4fu/CHxXBnyxXr15d8P379xQg5j/xzkzr948fuySk+Tg/
v/3K8OrRm9v//v3SAgggcBh8//FL6vvPP6pcbAwMzIz/GFiF1VgO32f7dYvVbj5Q85xv374d
U/2//c7vz9/c7l989O3lo5cb/vz9oX/jQPkfgAACh8GXb7+kGRj+Ag36z/D07TcGbg5GBk4h
abbfN6/sUVJSYhUTE2NYs2bNAXmWnVY3v1ppAjU+goUZQACBDfj8/bsoMyMDMLT/Aw37wfDq
/W8Gfi4WBhlFFdajlw8x6H+5x/Dz58/jGzdufAdU/g450AECCGzAx8/f1Xg4mRiAehk+ffsJ
8hLDy3e/GDhYmBk4ZYwZtp48/vvPX/0sbNENEEDMr8X82IBpeq+oABvzp68/GNiATgHqY2Bh
YmT4++8vw6P7r4Fx/r/qzNbyg9gMAAgglg+fv3/h42Ji/fvnD8PX7z8ZHj/9yPD5/VeG719+
MPwAJpzvn74e//v372RcCQ4ggFg+fPm2l+k/q8e1N58Znjx59/v31x9Vf3/9ufX3x6/Xf379
evr3359n1/eV/MFlAEAAsXz7/C3o06vf64AJxfnP9188p1cn/mIgAQAEGAAHb6YRb+SXdQAA
AABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenIndicateSharedContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJISURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
DWBA8gIIgw0BKQZ5CegVRqb/EHGwCxBeAAggsAEgDhMzODgYHj64TzAWmIFeghkAEEBwA9hY
WRg6UgyAUfqfgZWVleHVy5cM3Dx84MB9//4Ng4S4BMP379+hIY/wAkAAwQzoO3Bgvz1SKhMC
4n3S0tLJIP7t27fnAmknoNg7pFS5HqQXIIAYYdGHDPr7+/OBCvysbeyc+PkFGVYsX/wdyG9o
b2/vQlcLEEAoBkyePFkUaMsrVVU1BiFhEYa/fxiBiegPAzc3J8O9uzcZTp06+XXChAk8yAYA
BBALMgeYukxkZWUZPD09wM4EGQ7CTExMDCbGegzv3r3lTk9Pd585c+ZOmB6AAMLwQlNT0xmg
K4zRcyE0Z56eNWuWGbJ6gADCGgakAIAAAwD2s2ImVN243gAAAABJRU5ErkJggg=='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenIndicatedShared

	^ Icons
		at: #'xpfScreenIndicateShared'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenIndicateSharedContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 11:41'!
xpfScreenShare

	^ Icons
		at: #'xpfScreenShare'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenShareContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 11:38'!
xpfScreenShareContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAK4SURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
vcCA5AUQBhsCUgzyEtArr/+lMzz7Hc3AyARyGcILAAEEdgGIw8QMNovh4YP7WENeVPsng7yY
JsMnlVaGf0yr4QYABBDcADZWFoaOFANglP5nYGVlZZhxNgno1N8Mv/79AQbgHwYpIVUGTQlz
hs8/vjKU73Fj0PodAjYAIIBgBvQdOLDfHimVCf3h+6Xoqh0PjDpg6vz3FxjI/xmefXzMoCtj
zfDl13eGo99n/ddrmcIPEEBgA8LDw4uRndvf35//48+vCSDND9/eZvgNdMUfoGt+//3N8Onn
ZwYDWVuGL7+/MZ68f+QtQACxIGucPHmyKND2V6qqagxnX/4Axv8fBnE+OaDmv2CXPP/4iEGI
R4Lh3OOjDEfvHnn96w+DG0AAoRgATF0msrKyDJ6eHgwL5uQzLDzeAwyDXwxA1zAoiWgxWCi5
MZx+eIRh761dL4CanZ+1/b8GEECMsBQIA01NTWeArjBGz4UHxWYyGMnbMRy4tffpr39gzTdB
6gECCMMAXECpjvHr33/MXN///VV61fYfHtcAAQYAJ6iM87Uv3U4AAAAASUVORK5CYII='
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:17'!
xpfScreenUnShare

	^ Icons
		at: #'xpfScreenUnShare'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfScreenUnShareContent readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mfp 4/27/2009 13:18'!
xpfScreenUnShareContent

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAKjSURBVHjaTMWxDQAwCAMweJLf
uSUhqdoBdbCctqO7LSmumXlI7j8Ae1XlEUAsDEAAUiglJcPw4dMnBgaggQwQBGb/B1P/4WwQ
LSgowLB9+1YQjwEggOAGfPj4kSFv0lEGYkB3uinDr1+/wGyAAAIbAHISxHgGBhlZOQYeLjYG
WVFuBg52FoYfv/8z/P7zj+H3X6BFQDUnTl1g+P/vP8PPnz/B6gECiAlEgPwDdiYQMDIyMnz7
8YfhxYcfDN9+/gX76A9Q5y+gIT//QNSAxGAuAAggFpgB/2DuAxoAMuTztz8M//7/ZBDgZmVg
YWFmYALa+h9qwL///+AGAAQQ3ABgNED0Ixny/ddfhl+//zFwA73EzMzEwMQIsQOkFmYAQADB
DWBA8gIIgw0BKQZ5CegVRqb/EHGwCxBeAAggsAEgDhMzODgYHj64TzAWmIFeghkAEEBwA9hY
WRg6UgyAUfqfgZWVleHVy5cM3Dx84MB9//4Ng+C9QwzfDi9l+P38IcOLejEGaQ5lsAEAAQQz
oO/Agf32SKlMCIj3SUtLJ4P4TIcWnBbl+mRiFpnJyK6ozfD90i4G/sO7/+12Yc0FCCBGWPQh
g/7+/nygRj9rGzsnfn5BhrtlVv9ds6oYOe8eYGB4eoSBgV+A4Q2LPMO5XYfvAwQQC7LGyZMn
iwJtfqWqqsYgJCzC8AcYti9evGbg/vGJkUNCkYHBqwiulqVBkoH5H6MCQAChGABMXSaysrIM
np4eYK+AXAfCp8UkGb5d2MrAvSmL4ef3FwzfgGo/f2Jm+MvM8AwggDC80NTUdAboCmPkHKjx
8TKDPvNjBnnh3wwsTE8YPr/+w/DgJfPf3z/+1wEEENYwwAaORshVfH33LJ35L6P8X+b/T4G6
prvv+tMGEGAAgiZr9QKg/AwAAAAASUVORK5CYII='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mig 4/15/2009 19:01'!
xpfTakeResponsibility

	^ Icons
		at: #'xpfTakeResponsibility'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfTakeResponsibilityContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mig 4/15/2009 19:07'!
xpfTakeResponsibilityContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABUAAAAQCAMAAADOBMQXAAAABGdBTUEAALGOfPtRkwAAACBjSFJN
AAB6JQAAgIMAAPn/AACA6AAAdTAAAOpgAAA6lwAAF2+XqZnUAAABL1BMVEUAAAD////+/v/w8/nv
8vhRcamxv9hRcqlWdq1cfrS0wtrw8/jv8vdYe7FXea5fg7legbdhhbtghbpkiL5jh71mi8Bskshv
kMFojsNul8xwmc5yms91ntR6pNt5otiApNSHrd6Gq9xzndJ6ptx2oNV5o9l4oth7p9x6pNqHr9+F
rN2DqdmBp9aGrd2IsN95msSNtOOSueiNsd2RtOCRtN6dwOqcu+H+//8ARAAAPQAEVwALYQQecBg3
ijEUawsYaxAddhMdbxYkgBoldh40hSxcrlVhslpks11mtF9qt2JsuGRvuWdyvGotiiI0lCk8ni9D
pzU8jTJ1vWx7wHKBw3lJrjpOtD9SuUN5vm9/wnWFxXqIx3yKyH+NyoGPy4SSzIaUzYma0Y+Xzov+
/v7///+4j0A3AAAAZXRSTlP/////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
////ABlo0oMAAADRSURBVBjTY0gxUlfWUJFRkpbST4EDBi1DOBBHiKojgChCVJYRDkQQoqqMXGZ6
mgqK2jrykmCTnUCicozGplBgADbZwQ4oKsaoBwLh4WGhAf5+vk4OgS5WKQysEmrM3Cw84YlJ8bHR
IcFB3p7uzhYMKSmqjGwm6mEJcTFRkRE+Xh5urjaWQFE5Rl1DQ6h2O2t7W0fLFKCoGCOKmy0sU0Ci
rBIobrZMAYuCTAYDc6ZkRiGIL0CEHCNMmFEAISqGMIEdIcoqISosyM/Jy8fBygoWBQDqrkpzV06O
hgAAAABJRU5ErkJggg=='! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 5/14/2009 10:02'!
xpfUser

	^ Icons
		at: #'xpfUser'
		ifAbsentPut:[ Form fromBinaryStream: (Base64MimeConverter mimeDecodeToBytes: self xpfUserContents readStream) ].
! !

!MenuIcons class methodsFor: '*xpf-support' stamp: 'mt 5/14/2009 10:02'!
xpfUserContents

	^ 'iVBORw0KGgoAAAANSUhEUgAAABAAAAAQCAYAAAAf8/9hAAAABGdBTUEAAK/INwWK6QAAABl0
RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAJ3SURBVDjLpZNtSNNRFIcNKunF
1rZWBMJqKaSiX9RP1dClsjldA42slW0q5oxZiuHrlqllLayoaJa2jbm1Lc3QUZpKFmmaTMsa
Rp+kMgjBheSmTL2//kqMBJlFHx44XM7vOfdyuH4A/P6HFQ9zo7cpa/mM6RvCrVDzaVDy6C5J
JKv6rwSnIhlFd0R0Up/GwF2KWyl01CTSkM/dQoQRzAurCjRCGnRUUE2FaoSL0HExiYVzsQwc
j6RNrSqo4W5Gh6Yc4+1qDDTkIy+GhYK4nTgdz0H2PrrHUJzs71NQn86enPn+CVN9GnzruoYR
63mMPbkC59gQzDl7pt7rc9f7FNyUhPY6Bx9gwt4E9zszhWWpdg6ZcS8j3O7zCTuEpnXB+3MN
ZkUUZu0NmHE8XsL91oSWwiiEc3MeseLrN6woYCWa/Zl8ozyQ3w3Hl2lYy0SwlCUvsVi/Gv2J
wITnYPDun2Hy6jYuEzAF1jUBCVYpO6kXo+NuGMeBAgcgfwNkvgBOPgUqXgKvP7rBFvRhE1cr
p8Vq1noFYSlacVyqGk0D86gbART9BDk9BFnPCNJbCY5aCFL1Cyhtp0RWAp74MsKSrkq9guHy
vfMTtmLc1togpZoyqYmyNoITzVTYRJCiXYBIQ3CwFqi83o3JDhX6C0M8XsGIMoQ4OyuRlq1D
dZcLkmbgGDX1iIEKNxAcbgTEOqC4ZRaJ6Ub86K7CYFEo8Qo+GBQlQyXBczLZpbloaQ9k1NUz
/kD2myBBKxRZpa5hVcQslalatoUxizxAVVrN3CW21bFj9F858Q9dnIRmDyeuybM71uxmH9BN
BB1q6zybV7H9s1Ue4PM3/gu/AEbfqfWy2twsAAAAAElFTkSuQmCC'! !

TextMorph subclass: #XpfPluggableTextMorph
	instanceVariableNames: 'model getTextSelector isTruncatedWithEllipsis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfPluggableTextMorph class methodsFor: 'as yet unclassified' stamp: 'topa 4/17/2009 20:18'!
on: model getTextSelector: selector

	^ self new
		model: model;
		getTextSelector: selector;
		yourself
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'topa 1/2/2010 17:36'!
changed

	super changed.
	(self model notNil and: [self getTextSelector notNil])
		ifTrue: [
			self update: self getTextSelector.
			self font: XpfFontProvider sansFont].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector

	^ getTextSelector
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:48'!
getTextSelector: anObject

	getTextSelector := anObject.
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 15:53'!
isTruncatedWithEllipsis
	"Discard all linebreaks and show first line with ellipsis according to extent."

	isTruncatedWithEllipsis ifNil: [self isTruncatedWithEllipsis: false].
	^ isTruncatedWithEllipsis! !

!XpfPluggableTextMorph methodsFor: 'accessing' stamp: 'mt 4/28/2009 15:52'!
isTruncatedWithEllipsis: aBoolean

	isTruncatedWithEllipsis := aBoolean! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model

	^ model
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'SR 4/14/2009 11:47'!
model: anObject

	self model ifNotNil: [self model removeDependent: self].
	model := anObject.
	self model ifNotNil: [self model addDependent: self].
	self changed.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 16:00'!
modelData

	^ (self model perform: self getTextSelector) ifNil: ['']! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 11:39'!
update: aSymbol

	aSymbol = self getTextSelector ifTrue: [
		self isTruncatedWithEllipsis
			ifFalse: [self updateContents]
			ifTrue: [self updateContentsTruncated]].
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'mt 4/28/2009 16:00'!
updateContents

	self contentsWrapped: self modelData.
! !

!XpfPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'cs 4/29/2009 11:36'!
updateContentsTruncated

	self contents: (self modelData asString withoutLineEndingsTruncatedTo: 20).! !

!Morph methodsFor: '*xpf-support-polymorph' stamp: 'mt 4/6/2010 16:31:08'!
newColumnFor: controls
	
	|answer|
	answer := Morph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!Morph methodsFor: '*xpf-support-polymorph' stamp: 'mt 4/6/2010 16:31:20'!
newRowFor: controls
	
	|answer|
	answer := Morph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 0.
	controls do: [:m | answer addMorphBack: m].
	^answer! !

!Morph methodsFor: '*xpf-support-colors' stamp: 'mt 9/17/2009 10:59'!
palette

	^ XpfDefaultColorPalette! !

Morph subclass: #XpfUpdateModel
	instanceVariableNames: 'info state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Quickstart'!

!XpfUpdateModel class methodsFor: 'as yet unclassified' stamp: 'SR 4/30/2009 14:53'!
packages

	^ {
	'Rest-Server'. 
	'Rest-Client'.
	'Rest-Tests'.
	'Xpf-Server'.
	'Xpf-Client'.
	'Xpf-Tests'.
	'Xpf-Support'.
	'JSON'.
	'OSProcess'.
	'Xpf-Multipoint-Core'.
	'RFB'.
	'CodeSight'} collect: [:n | MCPackage named: n]! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:38'!
addWorkingCopyFor: pkg

	| repoUrl pkgNames maxVer fileName repo |
	pkg workingCopy repositoryGroup repositories size = 1 ifTrue: [
		repoUrl := UITheme current
			textEntryIn: World
			text: 'Please enter url to an HTTP repository for:', String cr, pkg name
			title: 'New Package'
			entryText: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/xpforums'.
    
		repoUrl ifNotNil: [
			repo := (MCHttpRepository location: repoUrl user: 'user' password: '').
			pkg workingCopy repositoryGroup addRepository: repo.
			
			repo password.
			"Checkout newest version of package."
			pkgNames := repo allVersionNames select: [:name | name startsWith: pkg name].
			maxVer := (pkgNames collect: [:name | (name findTokens: {$.}) last asNumber]) max.
			fileName := (pkgNames detect: [:v | v endsWith: maxVer asString]), '.mcz'.
			(repo loadVersionFromFileNamed: fileName) load]].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mig 5/15/2009 14:57'!
check

	self hasUpdates
		ifTrue: [self state: true; info: 'Update now!!'; color: Color green]
		ifFalse: [self state: false; info: 'No updates.'; color: Color gray].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:20'!
databaseResetNeededFor: someVersions

	someVersions do: [:version | (version package name startsWith: 'Xpf-Server') ifTrue: [
			^ UITheme current questionWithoutCancelIn: World text: 'Do you want to reset the database?' title: 'Database structure changed']].
	^ false! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:21'!
hasUpdates

	self class packages do: [:pkg |
		pkg workingCopy repositoryGroup repositories size = 1
			ifTrue: [^ true].
		pkg workingCopy possiblyNewerVersions size > 0
			ifTrue: [^ true]].
	^ false! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:50'!
info

	^ info! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:51'!
info: anObject

	info := anObject.
	self changed: #info.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 5/8/2009 12:43'!
initialize

	super initialize.
	self
		info: '...';
		height: 25;
		width: 25;
		state: false;
		check.
		
	"[[true] whileTrue: [
		(Delay forDuration: (Duration minutes: 5)) wait.
		self check]] fork."! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:24'!
newPackages

	^ self class packages select: [:pkg |
		pkg workingCopy repositoryGroup repositories size = 1].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:02'!
newVersions

	| result newerVersionNames newestVersionName maxVer fileName repo |
	result := OrderedCollection new.
	self class packages do: [:pkg |
		newerVersionNames := pkg workingCopy possiblyNewerVersions.
		newerVersionNames ifNotEmpty: [
			maxVer := (newerVersionNames collect: [:name | (name findTokens: {$.}) last asNumber]) max.
			newestVersionName := (newerVersionNames detect: [:v | v endsWith: maxVer asString]).
			repo := pkg workingCopy repositoryGroup repositories detect: [:r | r includesVersionNamed: newestVersionName].
			fileName := newestVersionName, '.mcz'.
			result add: (repo loadVersionFromFileNamed: fileName)]].
	^ result! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:50'!
state

	^ state! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:51'!
state: anObject

	state := anObject.
	self changed: #state.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:42'!
update

	| nv nvString np npString |
	self state ifFalse: [^ self check].
	
	np := self newPackages.
	
	npString := (np collect: [:v | v name])
		inject: ''
		into: [:old :each | old, String cr, each ].

	np ifNotEmpty: [
		(UITheme current
			questionWithoutCancelIn: World
			text: 'Do you want to add the following packages?', String cr, npString
			title: 'New packages available') ifTrue: [
				np do: [:pkg | self addWorkingCopyFor: pkg]]].
	
	nv := self newVersions.
	
	nvString := (nv collect: [:v | v package name])
		inject: ''
		into: [:old :each | old, String cr, each ].
	
	nv ifNotEmpty: [
		(UITheme current
			questionWithoutCancelIn: World
			text: 'Do you want to update the following packages?', String cr, nvString
			title: 'Updates available') ifTrue: [
			nv do: [:version | version merge].
			self check]].
	
	(self databaseResetNeededFor: nv) ifTrue: [
		XpfUser initialize.
		XpfProject initialize].
	
	(self updaterUpdated: nv) ifTrue: [
		XpfQuickstart open].
! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/17/2009 10:21'!
updaterUpdated: someVersions

	someVersions do: [:version | (version package name startsWith: 'Xpf-Support') ifTrue: [
			^ UITheme current questionWithoutCancelIn: World text: 'XpfQuickstart may have changed. Do you want to reopen the quickstart bar?' title: 'Xpf-Support package updated']].
	^ false! !

ImageMorph subclass: #XpfPluggableImageMorph
	instanceVariableNames: 'model selector formOn formOff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfPluggableImageMorph class methodsFor: 'as yet unclassified' stamp: 'mt 4/27/2009 13:29'!
formOn: formOn formOff: formOff model: model getOnOffSelector: selector

	^ self new
		formOn: formOn;
		formOff: formOff;
		selector: selector;
		model: model! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:23'!
formOff

	^ formOff! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOff: anObject

	formOff := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOn

	^ formOn! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
formOn: anObject

	formOn := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
model

	^ model! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:28'!
model: anObject

	model ifNotNil: [model removeDependent: self].
	model := anObject.
	model ifNotNil: [
		model addDependent: self.
		self updateImage].! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
selector

	^ selector! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:24'!
selector: anObject

	selector := anObject.! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:26'!
update: aSymbol

	super update: aSymbol.
	aSymbol = self selector ifTrue: [self updateImage].! !

!XpfPluggableImageMorph methodsFor: 'accessing' stamp: 'mt 4/27/2009 13:27'!
updateImage

	(self model perform: self selector)
		ifTrue: [self image: self formOn]
		ifFalse: [self image: self formOff].! !

PluggableButtonMorphPlus subclass: #XpfMultiPointButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Multipoint'!

!XpfMultiPointButton commentStamp: 'mt 12/30/2009 11:59' prior: 0!
I am aware of the hand that clicked me.!

!XpfMultiPointButton methodsFor: 'as yet unclassified' stamp: 'mt 4/6/2010 18:02:01.46'!
mouseUp: evt

	|all|
	all := allButtons copy.
	all ifNotNil: [all do: [:m |
		m changed]].
	all ifNil: [^ self].
	allButtons := nil.
	all do: [:m |
		(m containsPoint: evt cursorPoint) ifTrue: [m performActionForHand: ActiveHand]].
	self changed
! !

!XpfMultiPointButton methodsFor: 'as yet unclassified' stamp: 'mt 12/30/2009 12:10'!
performActionForHand: aHand
	"Only allow selectors that expect one argument."

	model perform: actionSelector with: aHand.! !

Object subclass: #XpfChangePasswordModel
	instanceVariableNames: 'newPassword newPasswordRepeat user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic-Models'!

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'bs 9/9/2009 17:30'!
accept

	(self newPassword = self newPasswordRepeat) ifTrue: [
		self user password: self newPassword.
		ActiveHand login: ActiveHand login password: self newPassword.
		(self user respondsTo: #repository) ifFalse: [^ self].
		(self user login = self user repository login)
			ifTrue: [self user repository password: self newPassword]].! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword

	^ newPassword! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:50'!
newPassword: anObject

	newPassword := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat

	^ newPasswordRepeat! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:45'!
newPasswordRepeat: anObject

	newPasswordRepeat := anObject.! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user

	^ user! !

!XpfChangePasswordModel methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:46'!
user: anObject

	user := anObject.! !

Object subclass: #XpfColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfColorPalette commentStamp: 'mt 9/17/2009 10:57' prior: 0!
I provide some basic color roles to be used in ProjectTalk classes. I am an abstract class.

Orderd by brightness: light, midlight, mid, middark, dark, verydark
Others: base, text!

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
base

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
dark

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
light

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
mid

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:37'!
middark

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:31'!
midlight

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:32'!
text

	self subclassResponsibility! !

!XpfColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:40'!
verydark

	self subclassResponsibility! !

XpfColorPalette subclass: #XpfDefaultColorPalette
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
base

	^ Color white! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:40'!
dark

	^ Color r: 0.7 g: 0.7 b: 0.7! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
light

	^ Color r: 0.98 g: 0.98 b: 0.98! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:38'!
mid

	^ Color r: 0.85 g: 0.85 b: 0.85! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:39'!
middark

	^ Color r: 0.8 g: 0.8 b: 0.8! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
midlight

	^ Color r: 0.92 g: 0.92 b: 0.92! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:34'!
text

	^ Color black! !

!XpfDefaultColorPalette class methodsFor: 'color roles' stamp: 'mt 9/6/2009 19:41'!
verydark

	^ Color r: 0.6 g: 0.6 b: 0.6! !

Object subclass: #XpfDemoData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-DemoData'!

!XpfDemoData class methodsFor: 'setup' stamp: 'cs 6/3/2009 15:23'!
addDevelopers: users to: anXpfProject

	users do: [:developer | anXpfProject addDeveloper: developer].! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
christopher

	^ {'userName' -> 'cs'. 
		'login' -> 'christopher.schuster@student.hpi.uni-potsdam.de'. 
		'password' -> 'hodufi16'}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
marcel

	^ {'userName' -> 'mt'. 
		'login' -> 'marcel.taeumel@student.hpi.uni-potsdam.de'. 
		'password' -> 'lilihu92'}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
max

	^ {'userName' -> 'mfp'. 
		'login' -> 'max.plauth@student.hpi.uni-potsdam.de'. 
		'password' -> 'wuseli83'}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
michael

	^ {'userName' -> 'mig'. 
		'login' -> 'michael.gruenewald@student.hpi.uni-potsdam.de'. 
		'password' -> 'pubawe51'}! !

!XpfDemoData class methodsFor: 'setup' stamp: 'cs 6/3/2009 15:22'!
setUp

	| root xpforums |
	root := XpfRoot new.
	self setUpUsers: root.
	xpforums := root addNewProject: (Dictionary newFrom: {'title' -> 'XP Forums'}).		
	self
		addDevelopers: root users to: xpforums;
		setUpAdminToolUserStory: xpforums;
		setUpHighlightUserStory: xpforums.
	XpfRoot production: root.! !

!XpfDemoData class methodsFor: 'userStories' stamp: 'SR 4/7/2009 11:51'!
setUpAdminToolUserStory: anXpfProject
	
	| adminTool |	
	adminTool := anXpfProject iterations first addNewUserStory: (Dictionary newFrom: {
		'title' -> 'Einfaches, administratives Werkzeug (UI und Serveranbindung) implementieren'.
		'priority' -> 'High'.
		'timeEstimated' -> 9.
		'timeActual' -> 21.5.
		'explanation' ->
'Ich moechte mit einem Werkzeug Nutzer und deren Projekte verwalten koennen.

    * Ich moechte einen neuen Nutzer erstellen/entfernen.
    * Ich moechte die Daten dieses Nutzers (Name, Login, Passwort usw.) auch mit diesem Tool modifizieren koennen.
    * Ich moechte ein neues Projekt anlegen koennen.
    * Ich moechte Nutzer zu Projekten hinzufuegen und entfernen koennen.
    * In dem Tool soll das Projekt (vorerst) nur minimal bearbeitbar sein (Name, Nutzer).
    * Ich kann mich nur als Admin anmelden.

Was ist ein Nutzer?

    * login (benutzername = e-mail-adresse)
    * passwort
    * name (nicht extra vorname, nachname - keine Probleme mit Mittelnamen)
    * Administrator heisst "admin", ist aber ein normaler Nutzer (mit Flag)'
	}).
	adminTool
		addNewTask: (Dictionary newFrom: self task73);
		addNewTask: (Dictionary newFrom: self task74);
		addNewTask: (Dictionary newFrom: self task75);
		addNewTask: (Dictionary newFrom: self task76);
		addNewTask: (Dictionary newFrom: self task77);
		addNewTask: (Dictionary newFrom: self task78);
		addNewTask: (Dictionary newFrom: self task79);
		addNewTask: (Dictionary newFrom: self task81);
		addNewTask: (Dictionary newFrom: self task82);
		addNewTask: (Dictionary newFrom: self task83);
		addNewTask: (Dictionary newFrom: self task84).! !

!XpfDemoData class methodsFor: 'userStories' stamp: 'SR 4/7/2009 11:51'!
setUpHighlightUserStory: anXpfProject
	
	| highlight |	
	highlight := anXpfProject iterations first addNewUserStory: (Dictionary newFrom: {
		'title' -> 'Farbliche Markierungen im Code erweitern'.
		'priority' -> 'Medium'.
		'timeEstimated' -> 12.
		'timeActual' -> 2.5.
		'explanation' ->
'Ich moehte die Moeglichkeit haben, den Code mit verschiedenen Farben zu markieren (gruen = guter Code, rot = schlechter Code, grau = unverstaendlicher Code). Hierbei spielt die Nutzbarkeit eine grosse Rolle.

Ich moechte aus einer kleinen Palette erst die Art der Markierung mit einem Mausklick auswaehlen und dann damit den entsprechenden Code markieren. Diese Palette sollte

Ich moechte ueber ein Tastenkuerzel die aktuelle Selektion des Codes in eine farbliche Markierung umwandeln.

Ich moechte ein Kontextmenue bei einer Selektion haben, welche mir verschiedene Arten von Markierung anbietet.
Acceptance Criteria

    * OB Package Browser oeffnen und eine Methode anzeigen.
    * Neuen "View" auswaehlen.
    * Aus der Palette "gut" auswaehlen und Code markieren.
    * Code markieren und [Cmd]+S (fuer schlecht == rot) druecken.
    * Code markieren und im Kontextmen "unverstaendlich" auswaehlen.
'}).
	highlight
		addNewTask: (Dictionary newFrom: self task48);
		addNewTask: (Dictionary newFrom: self task49);
		addNewTask: (Dictionary newFrom: self task50).! !

!XpfDemoData class methodsFor: 'setup' stamp: 'cs 6/3/2009 15:22'!
setUpUsers: root

	root
		addNewUser: (Dictionary newFrom: self christopher);
		addNewUser: (Dictionary newFrom: self marcel);
		addNewUser: (Dictionary newFrom: self max);
		addNewUser: (Dictionary newFrom: self michael);
		addNewUser: (Dictionary newFrom: self stefan);
		addNewUser: (Dictionary newFrom: self tobias).! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:22'!
stefan

	^ {'userName' -> 'SR'. 
		'login' -> 'stefanc.richter@student.hpi.uni-potsdam.de'. 
		'password' -> 'tifaha81'}! !

!XpfDemoData class methodsFor: 'tasks-highlight-code' stamp: 'cs 3/17/2009 15:54'!
task48

	^ {'title' -> 'Code-Markierung per Kontextmenue setzen'.
		'explanation' -> 'Im Kontextmenue einer Selektion sollen drei Eintraege fuer das Markieren (gruen, rot, grau) stehen - mit Symbol. Wenn man darauf klickt, wird der selektierte Code in der entsprechenden Farbe hervorgehoben.'.
		'timeEstimated' -> 2.
		'timeActual' -> 2.5}! !

!XpfDemoData class methodsFor: 'tasks-highlight-code' stamp: 'cs 3/17/2009 15:59'!
task49

	^ {'title' -> 'Zusaetzliche UI-Elemente im ''XPF-View'' anzeigen'.
		'explanation' -> 'Abhaengig vom View sollen neue UI-Elemente angezeigt werden.

Ziel: Zwischen OBPluggableTextMorphWithShout und OBEnhancementButtonBar steht eine Zeile Text mit den aktuellen Shortcuts fuer das Markieren.'.
		'timeEstimated' -> 6}! !

!XpfDemoData class methodsFor: 'tasks-highlight-code' stamp: 'cs 3/17/2009 15:59'!
task50

	^ {'title' -> 'Steuerelemente fuer Markierung im ''XPF-View'''.
		'explanation' ->
'Im View sollte es eine Art Palette geben, wo ich die Farbe auswaehlen kann. Dann markiere ich.

Entweder wird die Markierung sofort gesetzt, oder per Doppelklick oder sonstiger Bestaetigung. Dieser "Markiermodus" kann an- und abgewaehlt werden.'.
		'timeEstimated' -> 4}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:37'!
task73

	^ {'title' -> 'Verfuegbare Projekte anzeigen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:37'!
task74

	^ {'title' -> 'Verfuegbare Benutzer anzeigen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 2.5}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:37'!
task75

	^ {'title' -> 'Verfuegbare Projekte bearbeiten'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:38'!
task76

	^ {'title' -> 'Verfuegbare Benutzer bearbeiten'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:38'!
task77

	^ {'title' -> 'Neue Projekte anlegen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:39'!
task78

	^ {'title' -> 'Neue Benutzer anlegen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:39'!
task79

	^ {'title' -> 'Benutzer einem Projekt zuordnen/entfernen'.
		'explanation' -> ''.
		'timeEstimated' -> 2.
		'timeActual' -> 8}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:40'!
task81

	^ {'title' -> 'Administrator einfuehren'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 0.5}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:40'!
task82

	^ {'title' -> 'Administrator muss sich im System authentifizieren koennen'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 3}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:41'!
task83

	^ {'title' -> 'Projekte muessen geloescht werden koennen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1.5}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:41'!
task84

	^ {'title' -> 'Benutzer muessen geloescht werden koennen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
tobias

	^ {'userName' -> 'topa'. 
		'login' -> 'tobias.pape@student.hpi.uni-potsdam.de'. 
		'password' -> 'riwofe79'}! !

Object subclass: #XpfFontProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfFontProvider class methodsFor: 'defaults' stamp: 'topa 1/2/2010 17:31'!
font: n at: size
	
	TTCFont registry isEmpty ifTrue: [TTCFont registerAll].
	^  TTCFont familyName: n pointSize: size emphasis: 0! !

!XpfFontProvider class methodsFor: 'defaults' stamp: 'topa 1/2/2010 17:32'!
monoFont

	^ self monoFontAt: 10! !

!XpfFontProvider class methodsFor: 'defaults' stamp: 'topa 1/2/2010 17:32'!
monoFontAt: aPointSize

	^ self font: 'BitstreamVeraSansMono' at: aPointSize! !

!XpfFontProvider class methodsFor: 'defaults' stamp: 'topa 1/2/2010 17:33'!
sansFont

	^ self sansFontAt: 11! !

!XpfFontProvider class methodsFor: 'defaults' stamp: 'topa 1/2/2010 17:33'!
sansFontAt: aPointSize

	^ self font: 'BitstreamVeraSans' at: aPointSize! !

Object subclass: #XpfProjectChooserModel
	instanceVariableNames: 'projects projectsModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic-Models'!

!XpfProjectChooserModel methodsFor: 'initialization' stamp: 'mt 4/6/2010 18:20:18.206'!
initialize
	
	super initialize.
	
	projects := OrderedCollection new.
	projectsModel := SwaListModel new.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 14:04'!
project

	^ (self projectsModel selectionIndex = 0)
		ifTrue: [nil]
		ifFalse: [self projects at: self projectsModel selectionIndex]! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 11:45'!
projects
	^ projects! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'mfp 3/19/2009 11:19'!
projects: anObject

	projects := anObject.
	projectsModel list: (self projects collect: [:e | e title]).
	projectsModel list ifNotEmpty: [projectsModel selectionIndex: 1]. 
	self changed.! !

!XpfProjectChooserModel methodsFor: 'accessing' stamp: 'SR 3/10/2009 13:58'!
projectsModel
	^ projectsModel! !

Object subclass: #XpfQuickstart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Quickstart'!

!XpfQuickstart class methodsFor: 'user interface' stamp: 'mt 4/6/2010 16:28:21'!
createButton: actionSel label: aString
	
	| btn |
	btn := SwaPushButton
		label: aString
		receiver: self
		selector: actionSel.
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	^ btn! !

!XpfQuickstart class methodsFor: 'user interface' stamp: 'mig 4/27/2009 16:23'!
createUpdateButton
	
	| btn |
	btn := PluggableButtonMorph on: XpfUpdateModel new getState: #state action: #update label: #info.
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill;
		onColor: Color green offColor: Color white.
	^ btn! !

!XpfQuickstart class methodsFor: 'as yet unclassified' stamp: 'SR 9/1/2009 16:17'!
grabKeyboard

	MultiPointerManager multiPointerActive ifTrue: [
			ActiveHand isXpfMultiPointerHandMorph ifTrue: [
				ActiveHand keyboardIndex: nil.
				MultiPointerManager instance findKeyboardForHandMorph: ActiveHand]]! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 4/6/2010 16:26:18'!
installDemoData

	| result |
	result := true."UITheme current
		questionWithoutCancelIn: World
		text: 'Do you want to perform the following actions?', String cr, 'Reset Local Database.', String cr, 'Add BP2008H1-Developers',String cr, 'Add XP Forums Project'
		title: 'Install Demo Data?'."
	
	result ifTrue: [XpfDemoData setUp].! !

!XpfQuickstart class methodsFor: 'instance creation' stamp: 'mt 7/2/2009 22:51'!
open
	
	| align uBtn|
	align := AlignmentMorph newBounds: (50@50 corner: 700@80).
	align color: Color transparent.
"	uBtn := self createUpdateButton.
	align addMorph: uBtn.
	align addMorph: uBtn model.
"	
	{
		#grabKeyboard -> 'Grab Keyboard!!'.
"		#stopMultiPointer -> 'MP Stop'.
		#startMultiPointer -> 'MP Start'.
		#openPenetrationTool -> 'Penetration Tool'.
		#installDemoData -> 'Install Demo Data'.
		#resetLocalDatabase -> 'Reset Local DB'.
		#stopHttpService -> 'Stop Server'.
		#startHttpService -> 'Start Server'.
		#openUserStoryWidget -> 'US Widget'.
		#openTaskWidget -> 'Task Widget'.
		#openClientForServer -> 'Client'.
		#openAdminTool -> 'AdminTool'."
		#openHandLogin -> 'Login options'
	} do: [:assoc | align addMorph: (self createButton: assoc key label: assoc value)].

	align openInWorld.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'SR 4/11/2009 22:02'!
openAdminTool
	XpfAdminTool open! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'topa 1/2/2010 17:36'!
openClientForServer

	XpfProjectTalk open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'SR 7/1/2009 12:54'!
openHandLogin

	XpfUserPasswordForHand open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'cs 5/15/2009 11:02'!
openPenetrationTool

	XpfPenetrationTest open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'SR 4/11/2009 22:03'!
openTaskWidget

	XpfTaskListWidget open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'SR 4/11/2009 22:02'!
openUserStoryWidget

	XpfUserStoryListWidget open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 4/6/2010 16:25:39'!
resetLocalDatabase

	| result |
	result := true. "UITheme current
		questionWithoutCancelIn: World
		text: 'Do you want to perform the following actions?', String cr, 'XpfUser initialize.', String cr, 'XpfProject initialize.'
		title: 'Reset local database?'."
	
	result ifTrue: [
		XpfUser initialize.
		XpfProject initialize].! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'cs 5/19/2009 17:29'!
startHttpService

	RestHttpService start.! !

!XpfQuickstart class methodsFor: 'as yet unclassified' stamp: 'SR 5/6/2009 12:13'!
startMultiPointer

	MultiPointerManager startMoving.! !

!XpfQuickstart class methodsFor: 'model' stamp: 'mt 3/11/2009 14:58'!
state

	^ true! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'cs 5/19/2009 17:29'!
stopHttpService

	RestHttpService stop.! !

!XpfQuickstart class methodsFor: 'as yet unclassified' stamp: 'SR 5/6/2009 12:13'!
stopMultiPointer

	MultiPointerManager stopMoving.! !

Object subclass: #XpfUpdateTask
	instanceVariableNames: 'package newerVersionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Update'!

!XpfUpdateTask class methodsFor: 'instance creation' stamp: 'mt 4/9/2010 09:35:16.37'!
package: aMCPackage

	^ self new
		package: aMCPackage! !

!XpfUpdateTask methodsFor: 'info' stamp: 'mt 4/9/2010 10:27:13.499'!
currentVersionString

	self package
		ifNil: [^ '(No package.)'].
	self package workingCopy ancestry ancestors
		ifEmpty: [^ '(No version info.)'].
		
	^ self package workingCopy ancestry ancestors first name! !

!XpfUpdateTask methodsFor: 'accessing' stamp: 'mt 4/9/2010 09:54:36.109'!
newerVersionString
	^ newerVersionString! !

!XpfUpdateTask methodsFor: 'accessing' stamp: 'mt 4/9/2010 09:54:36.205'!
newerVersionString: anObject
	newerVersionString := anObject! !

!XpfUpdateTask methodsFor: 'accessing' stamp: 'mt 4/9/2010 09:34:47.283'!
package
	^ package! !

!XpfUpdateTask methodsFor: 'accessing' stamp: 'mt 4/9/2010 09:57:49.257'!
package: anObject

	package := anObject.
	self setNewerVersionString.! !

!XpfUpdateTask methodsFor: 'accessing' stamp: 'mt 4/9/2010 10:37:25.731'!
setNewerVersionString

	| pnv maxVer nvn |
	self package
		ifNil: [self newerVersionString: ''. ^ self].	
			
	pnv := self package workingCopy possiblyNewerVersions.
	
	pnv ifEmpty: [self newerVersionString: ''. ^ self].
	
	maxVer := (pnv collect: [:name | (name findTokens: {$.}) last asNumber]) max.
	nvn := (pnv detect: [:v | v endsWith: maxVer asString]).
	
	self currentVersionString = nvn
		ifTrue: [self newerVersionString: ''. ^self].
		
	self newerVersionString: nvn.! !

!XpfUpdateTask methodsFor: 'updating' stamp: 'mt 4/9/2010 10:02:00.66'!
update

	| repo |
	repo := self package workingCopy repositoryGroup repositories
		detect: [:r | r includesVersionNamed: self newerVersionString]
		ifNone: [^ self].
	
	(repo loadVersionFromFileNamed: self newerVersionString, '.mcz')
		merge.! !

!XpfUpdateTask methodsFor: 'info' stamp: 'mt 4/9/2010 09:58:27.219'!
updateAvailable

	^ self newerVersionString notEmpty! !

Object subclass: #XpfUpdater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Update'!

!XpfUpdater commentStamp: 'mt 4/9/2010 09:13:58.99' prior: 0!
I am used to update ProjectTalk conveniently.!

!XpfUpdater class methodsFor: 'accessing' stamp: 'mt 4/9/2010 09:47:23.596'!
newPackages
	"Choose those packages that have only a local cache repository which implies that they are new."
	
	^ self pvtPackageNames
		collect: [:packageName | MCPackage named: packageName]
		thenSelect: [:package | 
			package workingCopy repositoryGroup repositories size = 1]! !

!XpfUpdater class methodsFor: 'accessing' stamp: 'mt 4/9/2010 09:46:00.908'!
packages
	"Collect all packages that belong to ProjectTalk and that have repositories other than caches."

	^ self pvtPackageNames
		collect: [:packageName | MCPackage named: packageName]
		thenSelect: [:package | 
			(package workingCopy repositoryGroup repositories
				reject: [:repository | repository isKindOf: MCCacheRepository])
				notEmpty]! !

!XpfUpdater class methodsFor: 'private' stamp: 'mt 4/9/2010 09:45:33.639'!
pvtPackageNames

	^ {
	'Sport'.
	'Swazoo'.
	'SIXX'.
	'JSON'.
	'SwaUtil'.
	'Xpf-Support'.
	'Rest-Server'.
	'Rest-Client'.
	'Xpf-Multipoint-Core'.
	'Xpf-RestSupport'.
	'Xpf-Server'.
	'Xpf-AdminTool'.
	'Xpf-ProjectTalk'}! !

!XpfUpdater class methodsFor: 'updating' stamp: 'mt 4/9/2010 10:39:25.488'!
update

	| tasks msg |
	tasks := self packages
		collect: [:package |	XpfUpdateTask package: package]
		thenSelect: [:task | task updateAvailable].
		
	tasks ifEmpty: [UserDialogBoxMorph
		inform: 'No updates available.'
		title: 'ProjectTalk'.
		^ self].
	
	msg := tasks
		inject: 'Do you want to update?', String cr
		into: [:text :task | text, String cr, task currentVersionString, ' --> ', task newerVersionString].
		
	(UserDialogBoxMorph
		confirm: msg
		title: 'ProjectTalk') ifTrue: [
			tasks
				do: [:task | task update]
				displayingProgress: [:task | 'Merging ', task newerVersionString, '...']].! !

SystemWindow subclass: #XpfSystemWindow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfSystemWindow commentStamp: 'mt 10/6/2009 09:30' prior: 0!
I am a System Window that provides some Polymorph functionalities.!

!XpfSystemWindow class methodsFor: 'constants' stamp: 'mt 10/6/2009 09:44'!
borderWidth

	^ 2! !

!XpfSystemWindow class methodsFor: 'constants' stamp: 'mt 10/6/2009 09:57'!
defaultHeight

	^ 500! !

!XpfSystemWindow class methodsFor: 'constants' stamp: 'mt 10/6/2009 09:57'!
defaultWidth

	^ 800! !

!XpfSystemWindow methodsFor: 'initialization' stamp: 'mt 10/6/2009 09:41'!
addMainPanel: aMorph
	"Use the whole window space for the main panel."

	self
		addMorph: aMorph
		frame: (0@0 corner: 1@1).! !

!XpfSystemWindow methodsFor: 'dialog' stamp: 'mt 10/6/2009 09:36'!
cancel
	"Cancel and close."

	self close! !

!XpfSystemWindow methodsFor: 'dialog' stamp: 'mt 10/6/2009 09:36'!
close
	"Close the window."

	self delete! !

!XpfSystemWindow methodsFor: 'support' stamp: 'mt 10/6/2009 09:32'!
createCol: someMorphs

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 8.
	someMorphs do: [:m | answer addMorphBack: m].
	^answer! !

!XpfSystemWindow methodsFor: 'support' stamp: 'mt 10/6/2009 09:55'!
createHSpacer

	^ Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 3@3;
		hResizing: #spaceFill! !

!XpfSystemWindow methodsFor: 'support' stamp: 'mt 10/6/2009 09:31'!
createRow: someMorphs

	|answer|
	answer := PanelMorph new
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		listDirection: #leftToRight;
		cellInset: 8.
	someMorphs do: [:m | answer addMorphBack: m].
	^answer! !

!XpfSystemWindow methodsFor: 'support' stamp: 'mt 10/6/2009 09:56'!
createVSpacer

	^ Morph new
		borderWidth: 0;
		color: Color transparent;
		extent: 3@3;
		vResizing: #spaceFill! !

!XpfSystemWindow methodsFor: 'initialization' stamp: 'mt 10/6/2009 10:05'!
initialExtent
	"Used by World>>openModal:"
	
	^ self class defaultWidth @ self class defaultHeight! !

!XpfSystemWindow methodsFor: 'dialog' stamp: 'mt 10/6/2009 09:36'!
ok

	self delete.! !

!XpfSystemWindow methodsFor: 'initialization' stamp: 'mt 10/6/2009 09:58'!
openInWorld
	"You can only resize this window after it is shown. Do this here."

	super openInWorld.
	self
		panelHeight: self class defaultHeight;
		width: self class defaultWidth.! !

!XpfSystemWindow methodsFor: 'accessing' stamp: 'mt 10/6/2009 09:41'!
panelHeight

	^ self panelRect height - self class borderWidth! !

!XpfSystemWindow methodsFor: 'accessing' stamp: 'mt 10/6/2009 09:41'!
panelHeight: aNumber
	"Set the height of the main panel. Add some space for the window frame."
	
	self height: aNumber + self labelHeight + (self class borderWidth * 2).! !

!XpfSystemWindow methodsFor: 'accessing' stamp: 'mt 10/6/2009 09:50'!
title: aString

	self setLabel: aString.! !

ScrollPane subclass: #XpfScrollPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/9/2009 13:57'!
extent: newExtent

	super extent: newExtent.
	self scroller submorphsDo: [:each | each adjustLayoutBounds].
	^self.! !

!XpfScrollPane methodsFor: 'as yet unclassified' stamp: 'SR 4/10/2009 12:05'!
toggleShow

	self
		visible: self visible not;
		disableTableLayout: self visible not! !

PluggableTextMorph subclass: #XpfSaveEditingTextMorph
	instanceVariableNames: 'isBlocked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfSaveEditingTextMorph methodsFor: 'updating' stamp: 'topa 4/22/2009 15:22'!
update: aSymbol

	self hasUnacceptedEdits ifFalse: [super update: aSymbol].! !

SwaDialog subclass: #XpfChangePasswordDialog
	instanceVariableNames: 'okButton cancelButton oldPasswordEntry newPasswordEntry newPasswordRepeatEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfChangePasswordDialog class methodsFor: 'constants' stamp: 'mt 4/6/2010 16:22:29'!
defaultHeight

	^ 175! !

!XpfChangePasswordDialog class methodsFor: 'constants' stamp: 'mt 4/6/2010 16:22:06'!
defaultWidth

	^ 375! !

!XpfChangePasswordDialog class methodsFor: 'as yet unclassified' stamp: 'mt 4/4/2010 12:03:23'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 4/6/2010 16:18:55'!
createNewPasswordEntryFor: anXpfChangePasswordModel

	self newPasswordEntry: (SwaLineEdit 
		for: anXpfChangePasswordModel 
		get: #newPassword
		set: #newPassword:
"		class: String
		getEnabled: nil"
		help: 'Enter new password').
	self newPasswordEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 4/6/2010 16:19:18'!
createNewPasswordRepeatEntryFor: anXpfChangePasswordModel

	self newPasswordRepeatEntry: (SwaLineEdit
		for: anXpfChangePasswordModel 
		get: #newPasswordRepeat
		set: #newPasswordRepeat:
"		class: String
		getEnabled: nil"
		help: 'Repeat new password').
	self newPasswordRepeatEntry textMorph font: (StrikeFont passwordFontSize: 12).
	^ self newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 4/6/2010 16:59:09'!
initialize

	| myModel |
	super initialize.
	myModel := XpfChangePasswordModel new.
	self
		buttons: {
			self createOkButton: 'Ok'.
			self createCancelButton: 'Cancel'};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Change Password'.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 4/4/2010 12:59:22'!
initializeUserInterface: anXpfChangePasswordModel

	^ self createCol: {
		self createLabel: 'Please DO NOT use an existing password.'.
		self createLabel: 'Your credentials will be transmitted in plain text.'.
		self createRow: {
			self createLabel: 'New:'.
			self createNewPasswordEntryFor: anXpfChangePasswordModel}.
		self createRow: {
			self createLabel: 'Confirm:'.
			self createNewPasswordRepeatEntryFor: anXpfChangePasswordModel}}! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry

	^ newPasswordEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:56'!
newPasswordEntry: anObject

	newPasswordEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry

	^ newPasswordRepeatEntry! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/31/2009 14:39'!
newPasswordRepeatEntry: anObject

	newPasswordRepeatEntry := anObject.! !

!XpfChangePasswordDialog methodsFor: 'as yet unclassified' stamp: 'mt 3/31/2009 14:47'!
ok

	self newPasswordEntry accept.
	self newPasswordRepeatEntry accept.
	self model accept.
	super ok.! !

!XpfChangePasswordDialog methodsFor: 'accessing' stamp: 'mt 3/30/2009 17:57'!
oldPasswordEntry: anObject

	oldPasswordEntry := anObject.! !

SwaDialog subclass: #XpfProjectChooser
	instanceVariableNames: 'projectDropList result passwordChangeDialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Morphic'!

!XpfProjectChooser class methodsFor: 'constants' stamp: 'mt 4/7/2010 16:57:47.711'!
defaultHeight

	^ 100! !

!XpfProjectChooser class methodsFor: 'constants' stamp: 'mt 4/7/2010 16:57:18.011'!
defaultWidth

	^ 400! !

!XpfProjectChooser class methodsFor: 'as yet unclassified' stamp: 'mt 4/4/2010 12:03:39'!
open

	[^ self new
		initializeWith: XpfTaskbarExtension instance connection repository;
		openInWorld]
		on: XpfClientOpenError
		do: [:nothing | ].! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:26:11.825'!
createChangePasswordButton

	^ SwaPushButton
		label: 'Change Password'
		receiver: [self openModal: self passwordChangeDialog]
		selector: #value
		help: 'Change your password'! !

!XpfProjectChooser methodsFor: 'user interface helper' stamp: 'mt 4/6/2010 18:25:51.956'!
createProjectDropList: myModel

	^ SwaComboBox 
		on: myModel projectsModel
		list: #list
		selected: #selectionIndex
		changeSelected: #selectionIndex:
		"help: 'Enter project id'"! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'mt 4/6/2010 18:26:19.117'!
initialize

	| myModel |
	super initialize.
	
	myModel := XpfProjectChooserModel new.
	
	self
		buttons: {
			self createOkButton: 'Ok'.
			self createCancelButton: 'Cancel'.
			self createChangePasswordButton};
		contentMorph: (self initializeUserInterface: myModel);
		model: myModel;
		addGrips;
		title: 'Specify Project'.! !

!XpfProjectChooser methodsFor: 'initialization' stamp: 'SR 3/10/2009 13:54'!
initializeUserInterface: myModel

	^ self createCol: {
		self createRow: {
			self createLabel: 'Project:'.	self createProjectDropList: myModel}}! !

!XpfProjectChooser methodsFor: 'actions' stamp: 'SR 3/10/2009 14:00'!
ok

	self result: self model project.
	
	^ super ok! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog

	^ passwordChangeDialog! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 3/31/2009 13:06'!
passwordChangeDialog: anObject

	passwordChangeDialog := anObject.! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:27:51.818'!
result
	^ result! !

!XpfProjectChooser methodsFor: 'accessing' stamp: 'mt 4/6/2010 18:27:51.882'!
result: anObject
	result := anObject! !
XpfScrollBar initialize!
